/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003      by Advanced Data Controls, Corp
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *                2009 by Suikan
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *
 */

/*
 *    ^[QbgVXeˑW[iCQ-FRK-NXP-ARMj
 */

#include "jsp_kernel.h"
#include <lpc2388.h>

/*
 *  ݗp̃e[u
 */
#define VICVectAddress ((volatile FP **)0xFFFFF100)




/*
 *  ݊֘Ȁ(LPC2388)
 */
void
init_IRQ()
{
	int i;

	for( i=0; i<32; i++ )
		VICVectAddress[i] = (volatile FP *)undef_interrupt;
}

extern unsigned int __data_start;

/*
 * LPC2388SRAM̈FLASH̃xNgRs[A
 * }bvBLPC2388ʂŕKvB
 */
void
init_vector()
{
	unsigned char *flash, *sram;
	int i;

		/* ROMR[hSRAMœR[hł́AOxNg̈ႤB
		 * ROMꍇ́ASRAM REMAP̑OFlash ROM̗OxNg̒l
		 * SRAM̃}bv̈ɈڂȂ΂ȂȂBASRAMœ삷
		 * ꍇ́A}bv̈ւ̓fobKlށB
		 * ̂߁A}bv̈̏菇Kvۂ̔ʂsBʂ
		 * __data_start̒lgB̒llpc2388_sram.ld̒0ɏ
		 * Blpc2388.ld̒ł͔[̃AhXBāA
		 * }bv̈̏__data_start[̂ƂsB */
	if ( __data_start != 0 )
	{
		flash =(unsigned char*) 0;				/* FLASH̐擪AhX */
		sram = (unsigned char*) 0x40000000;	/* SRAM̐擪AhX */

			/* FLASH̐擪64oCgSRAMɃRs[ */
		for (i=0; i<64; i++)
		{
			*sram = *flash;
			sram++;
			flash++;
		}
	}
		/* SRAM xNgGAɃ}bv */
	MEMMAP = 0x02;
}

/*
 * LPC2388ˑUART[`Bsys_putc()puart0B
 */
#define	DLAB 0x80
void
init_uart0()
{
    /*
     *  ̐ݒ
     */
    /* Divisor Enable */
	U0LCR |= DLAB;
    U0DLL = UART0_DIVISOR & 0xFF ;
    U0DLM = UART0_DIVISOR >> 8;
    /* Divisor Disable */
    U0LCR &= ~DLAB;

    /* [hݒ, peB 8bit data, 1 stop bit */
    U0LCR = 0x03;

    /* ݋֎~ */
    U0IER = 0;
}

/*
 *  VXeItbNBt@[EFAɃVXeIAPIȂ
 *  ĂԂƂ悢B
 */
void
sys_exit()
{
	while(1)
		;
}



/*
 *  ^[QbgVXe̕óBsyslog^XNNOɃvgs߂
 *  [`łAł̓|[OsĂBLFLĂA
 *  CR LFɕϊăvgBsys_putc̓foCXȂB
 *  kernel_start()̒ŏIĂƉ肵ĂB
 */

void
sys_putc(char c)
{
	if ( c== 0x0A )			/*  LF Ȃ */
		sys_putc( 0x0D );	/* CRꕶM */

	while( !( U0LSR & (1<<5)) )
		;		/* UART0 LSRTHRE1ɂȂ܂ő҂B1ȂΑMWX^󂫁B*/

	U0THR = c;	/* ꕶM */
}


/*
 *  ݃nh̐ݒ
 *
 *  ݔԍ inhno ̊݃nh̋NԒn inthdr ɐݒ肷D
 *  VICVectAddress[]͓̃WX^Ƀ}bvĂBāA
 *  define_inhĂԂƁAVICVectAddressXWX^B
 */
void
define_inh(INHNO inhno, FP inthdr)
{
    assert(inhno <= MAX_INT_NUM);
    VICVectAddress[inhno] = (volatile FP*)inthdr;

}

/*
 *  `݂̊ꍇ̏
 */
void
undef_interrupt(){
    syslog(LOG_EMERG, "Unregistered Interrupt occurs.");
    while(1);
}


/*
 * 荞݂̃Cl[uAfBZ[u
 */
/*
 * intnoł킳銄荞݂fBZ[uɂȂB
 */
ER dis_int(INTNO intno)
{
	if ( intno > MAX_INT_NUM )
		return E_PAR;
	VICIntEnClr = 1<<intno;
	return 0;
}

/*
 * intnoł킳銄荞݂Cl[uɂȂB
 */
ER ena_int(INTNO intno)
{
	if ( intno > MAX_INT_NUM )
		return E_PAR;
	VICIntEnable = 1<<intno;
	return 0;
}

/*
 * 荞݃Cl[u}XNw肷B}XNVICIntEnableɑ
 */
ER chg_ims(unsigned int enableMask)
{
	VICIntEnClr = 0xFFFFFFFF;
	VICIntEnable = enableMask;
	return 0;
}

/*
 * 荞݃Cl[u}XN擾B
 */
ER get_ims(unsigned int *p_enableMask)
{
	*p_enableMask = VICIntEnable;
	return 0;
}


