/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *                2003      by  Advanced Data Controls, Corp
 *                2009 by Suikan
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *
 */

/*
 *  CPUˑ^C}W[iCQ-FRK-NXP-ARMpj
 *  TIMER3gp
 */

#ifndef _HW_TIMER_H_
#define _HW_TIMER_H_

#include <s_services.h>
#include "lpc2388.h"




/*
 *  ^C}݂̊ݔԍ
 */
#define    INHNO_TIMER    INHNO_TIMER3

#ifndef _MACRO_ONLY

/*
 *  ^C}l̓\̌^
 */
typedef UW    CLOCK;

/*
 *  ^C}l̓\ƃ~bEʕbPʂƂ̕ϊ
 *  TIMER_CLOCK ̓^[Qbg{[hɐݒ
 */
#define TO_CLOCK(nume, deno) (LP2388_SYSTEM_TIMER3_CLOCK/1000 * (nume) / (deno))
#define TO_USEC(clock)       ((clock) * 1000 / TIMER_CLOCK)

/*
 *  ݒłő̃^C}iPʂ͓\j
 */
#define MAX_CLOCK    ((CLOCK) 0xffffffff)
/*
 *  ^C}̌ݒlݔO̒lƂ݂Ȃ̔f
 */
#define GET_TOLERANCE    100
#define BEFORE_IREQ(clock) \
        ((clock) >= TO_CLOCK(TIC_NUME, TIC_DENO) - GET_TOLERANCE)

/*
 *  ^C}̋N
 *
 * ^C}CIȃ^C}ݗv𔭐D^C}[3ƃ}b`WX^0gB
 * OŒ`PCLK (Hz)NbN͂ƂĎgB
 */
Inline void
hw_timer_initialize()
{

    /*
     *  ^C}֘A̐ݒ
     */
    		/* ^C}~уZbg */
    T3TCR = 0x0002;
    		/* ݂̃NA  */
    T3IR =  0x0001;				/* MR0荞݂̃NA */

	T3CTCR = 0;			/* PCLK̃GbW𐔂BLv`͖͂ */
	T3PR = 0;			/* PCLK̃GbWׂĐBvXP[Ȃ */
    T3MR3 = (LP2388_SYSTEM_TIMER3_CLOCK/1000) -1;		/* 1mSƂɃ}b` */
	T3MCR = 0x3 << 9;	/* MR3S:R:I = 0:1:1B}b`JE^ZbgA荞݂ */

	T3TCR = 1;			/* TIMER3JEgJnɂ */

		/* ^C}[荞݂Lɂ */
	VICIntEnable = 1<< INHNO_TIMER;
}

/*
 *  ^C}ݗṽNA
 */
Inline void
hw_timer_int_clear()
{
    		/* ݂̃NA  */
	T3IR = 1<<3;			/* MR3}b`̊荞݂NA */
}

/*
 *  ^C}̒~
 */
Inline void
hw_timer_terminate()
{
    		/* ^C}~уZbg */
    T3TCR = 0x0002;
    		/* ݂̃NA  */
    T3IR =  0x0001;				/* MR0荞݂̃NA */
}

/*
 *  ^C}̌ݒl̓ǂ݂
 *
 *  ݋֎~ԒŌĂяoƁD
 */
Inline CLOCK
hw_timer_get_current(void)
{
    return(T3TC);
}

Inline BOOL
hw_timer_fetch_interrupt(void)
{
    return(T3IR & (1<<3));		/* MR3 }b`Ă^ */
}

#endif /* _MACRO_ONLY */
#endif /* _HW_TIMER_H_ */



