/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *                2003      by Advanced Data Controls, Corp
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id$
 */


/*
 *  ^[QbgVXeɈˑ`iAt91sam7spj
 *
 *  ̃CN[ht@ĆCkernel.h  sil.h ŃCN[hD
 *  ̃t@C璼ڃCN[h邱Ƃ͂ȂD̃t@CC
 *  N[hOɁCt_stddef.h  itron.h CN[ĥŁC
 *  ɈˑĂ悢D
 */

#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/*
 *  NbZ[W̃^[QbgVXe
 */
#define TARGET_NAME "ARM - AT91SAM7S"
#define AT91SAM7S

/* J[lÑbZ[W   */
#define COPYRIGHT_SYS \
"Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN\n"

#ifdef VECTOR_IN_ROM
#define RAM_START       0x00200000
#else  /* VECTOR_IN_ROM */
#define RAM_START       0x00000000
#endif /* VECTOR_IN_ROM */

#ifndef RAM_SIZE
#if defined (__AT91SAM7S128__)
#define RAM_SIZE        (32*1024)
#elif defined (__AT91SAM7S256__)
#define RAM_SIZE        (64*1024)
#endif
#endif

#define FIQ_DATA_SIZE   256
#define STACKTOP        (RAM_START+RAM_SIZE-FIQ_DATA_SIZE)  /* ^XNReLXgp̃X^bN̏l */

/*
 *  ^C}l̓\ƃ~bPʂƂ̕ϊ
 */
#define TIMER_CLOCK     5990

/*
 *  VECTOR MODE
 */
//#define VECTOR_IN_ROM

/*
 *  ^[QbgVXeˑ̃T[rXR[
 */
#ifndef _MACRO_ONLY


/*
 *  INTNO^Ɗ݂̋֎~/
 */
typedef    UINT        INTNO;        /* ݔԍ */
typedef    UINT        INHNO;        /* ݃nhԍ */


typedef    UD  SYSUTIM;    /* \]pVXe */
extern ER   vxget_tim(SYSUTIM *pk_sysutim) throw();

#endif /* _MACRO_ONLY */


/*
 *  ^CeBbN̒`
 */
#define    TIC_NUME    1        /* ^CeBbN̎̕q */
#define    TIC_DENO    1        /* ^CeBbN̎̕ */

/*
 *  ԑ҂̂߂̒`
 */
#define    SIL_DLY_TIM1     20
#define    SIL_DLY_TIM2     10

/*
 *  vZbT̃GfBA
 */
#define    SIL_ENDIAN    SIL_ENDIAN_LITTLE    /* gGfBA */

#ifndef _MACRO_ONLY
/*
 * VXe̒f
 */

Inline void
kernel_abort()
{
   while(1);
}

#endif /* _MACRO_ONLY */

#endif /* _SYS_DEFS_H_ */
