/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003      by Advanced Data Controls, Corp
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *                2009 by Suikan
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *
 */

/*
 *    ^[QbgVXeˑW[iCQ-FRK-NXP-ARMj
 */

#include "jsp_kernel.h"
#include <lpc2388.h>



/*
 * OSC̏(VXeŗL). 4MHz ̓IV[^g
 */
static void
init_clock()
{
	/* 1. PLLgpĂȂAfBXRlNgAtB[hEV[PX𓥂 */
	PLLCON &= 0xFFFFFFFD;	/* Clear bit 1, PLL bypassed */
	PLLFEED = 0xAA;
	PLLFEED = 0x55;

	/* 2. PLLfBZ[uAtB[hEV[PX𓥂ށB */
	PLLCON = 0;		/* Disable PLL */
	PLLFEED = 0xAA;
	PLLFEED = 0x55;

	/* 3. CPUNbNEfBoC_̐ݒAPLLȂłxȂ肷Ȃ悤ɐݒ肷B */
	CCLKCFG = 0;	/* CCLK = PCLK / 1 */

	/* 4. PLL̃NbN\[XύXB */
	CLKSRCSEL = 0;	/* Select 4MHz internal oscillator*/
//	CLKSRCSEL = 1;	/* Select 12MHz main oscillator*/

	/* 5. PLLCFGւ݂̏sAtB[hEV[PX𓥂ŗLB
	 * PLLCFǴAPLLfBZ[ûƂɂύXłB */
	PLLCFG = 35;	/* Divide by 1, Multiply by 72, PCLK = 4*72 = 288MHz */
//	PLLCFG = 11;	/* Divide by 1, Multiply by 24, PCLK = 12*24 = 288MHz */
	PLLFEED = 0xAA;
	PLLFEED = 0x55;

	/* 6. PLLCl[uɂAtB[hEV[PX𓥂. */
	PLLCON = 1;		/* Enable PLL */
	PLLFEED = 0xAA;
	PLLFEED = 0x55;

	/* 7. CPUNbNEfBoC_̒lAPLLpɕύXB
	 * ͕KAPLLNbNƂĐڑOɍsB */
	CCLKCFG = 3;	/* CCLK = PCLK/4 = 288/4 = 72MHz */

	/* 8. PLLSTATWX^PLOCK bit𒲂ׂāAPLLbN܂ő҂B
	 * 邢PLOCK荞݂gpĂB邢́APLL̓̓NbN(32kHzȂ)ȂA
	 * PɃEFCgE[v񂵂ĂB*/
	while ( !(PLLSTAT & (1<<26)))
		;

	/* 9. PLLVXeɐڑAtB[hV[PXs */
	PLLCON = 3;		/* Select PLL as CPU clock source */
	PLLFEED = 0xAA;
	PLLFEED = 0x55;
}




/*
 *  ^[QbgVXeˑ̏
 */
void
sys_initialize()
{
    int i;

    init_vector();			/* SRAM̃}bvBLPC2388 */

    init_clock();			/* PLL̐ݒBVXeŗL */

    init_uart0();			/* UART0̏BVXeŗL */

    init_IRQ();				/* VICBLPC2388 */

    		/* KvȃytF̓d(VXeŗL) */
			/* ȂAUART0TIMER3LPC2388ʂŕKv */
	PCONP |= 0x00800008;	/* bit3:UART0, bit23:TIMER3 */

			/* UART0̃sݒ (LPC2388) */
	PINSEL0 &= ~0xF0;			/* bit 4-7NA */
	PINSEL0 |= 0x50;			/* UARTo͂蓖 */

    /*
     *  ARM̃xN^e[u֊݃nho^iǂARMv4VXełvj
     */
    arm_install_handler(IRQ_Number,IRQ_Handler);

}





