/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2007 by KURUSUGAWA Electronics Industry Inc, JAPAN
 *  Copyright (C) 2008 by Takahisa Yokota
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: cpu_config.c,v 1.10 2005/11/12 14:57:17 hiro Exp $
 */

/*
 *	vZbTˑW[iCOLDFIREpj
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"

/*
 *  ^XNReLXgł̊݃}XN
 */
#ifdef SUPPORT_CHG_IPM
UH	task_intmask;
#endif /* SUPPORT_CHG_IPM */

/*
 *  ^XNReLXgł̊݃}XN
 */
UH	int_intmask;

/*
 *  ݁^CPUOlXgJE^
 */
UW      intnest;

extern void board_leds_display (unsigned char number);
/*
 *  vZbTˑ̏
 */
void
cpu_initialize()
{
	/*
	 *  ^XNReLXgł̊݃}XN̏
	 */
#ifdef SUPPORT_CHG_IPM
	task_intmask = 0x0000;
#endif /* SUPPORT_CHG_IPM */

	/*
	 *  ݁^CPUOlXgJE^̏
	 */
	intnest = 1u;
        
	/*
	 *  OxN^e[ȕ
	 */
#ifdef KERNEL_HAS_A_VECTOR_TABLE
        if ((UW)&vector_table != current_vbr()) {
	     set_vbr(vector_table);
        }
#endif /* KERNEL_HAS_A_VECTOR_TABLE */
}

/*
 *  vZbTˑ̏I
 */
void
cpu_terminate()
{
#ifdef KERNEL_HAS_A_VECTOR_TABLE
  if ((UW)&vector_table != EXCVT_ORIG) {  
	set_vbr(EXCVT_ORIG);
  }
#endif /* EXCVT_KERNEL */
}

#ifdef SUPPORT_CHG_IPM

/*
 *  ݃}XN̕ύX
 *
 *  chg_ipm g IPM  7iNMI ȊÔׂĂ݂̊֎~jɕύX
 *  邱Ƃ͂łȂDNMI ȊÔׂĂ݂̊֎~ꍇɂ́C
 *  loc_cpu ɂCPUbNԂɂ΂悢D
 *  IPM  0 ȊO̎ɂC^XNfBXpb`͕ۗȂDIPM ́C
 *  ^XNfBXpb`ɂāCVsԂɂȂ^XNֈp
 *  D̂߁C^XNsɁCʂ̃^XNɂ IPM ύX
 *  ꍇDJSPJ[lł́CIPM ̕ύX̓^XNO[`
 *  ɂĂN̂ŁCʂ̃^XNɂ IPM ύX邱Ƃ
 *  āCȂ󋵂͏ȂƎvDIPM ̒lɂă^
 *  XNfBXpb`֎~ꍇɂ́Cdis_dsp 𕹗p΂悢D
 */
SYSCALL ER
chg_ipm(IPM ipm)
{
	ER	ercd;

	LOG_CHG_IPM_ENTER(ipm);
	CHECK_TSKCTX_UNL();
	CHECK_PAR(0 <= ipm && ipm <= 6);

	t_lock_cpu();
	task_intmask = (ipm << 8);
	ercd = E_OK;
	t_unlock_cpu();

    exit:
	LOG_CHG_IPM_LEAVE(ercd);
	return(ercd);
}

/*
 *  ݃}XN̎Q
 */
SYSCALL ER
get_ipm(IPM *p_ipm)
{
	ER	ercd;

	LOG_GET_IPM_ENTER(p_ipm);
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	*p_ipm = (task_intmask >> 8);
	ercd = E_OK;
	t_unlock_cpu();

    exit:
	LOG_GET_IPM_LEAVE(ercd, *p_ipm);
	return(ercd);
}

#endif /* SUPPORT_CHG_IPM */

/*
 * o^ĂȂOƌĂяo
 */
void cpu_experr(EXCSTACK *sp)
{
    syslog(LOG_EMERG, "Exception error occurs.");
    
    syslog(LOG_EMERG, "PC = 0x%08x SR = 0x%08x",
    			sp->pc, sp->sr);
    
    syslog(LOG_EMERG, "d0 = 0x%08x d1 = 0x%08x d2 = 0x%08x",
    			sp->d0, sp->d1, sp->d2);
    syslog(LOG_EMERG, "d3 = 0x%08x d4 = 0x%08x d5 = 0x%08x",
    			sp->d3, sp->d4, sp->d5);
    syslog(LOG_EMERG, "d6 = 0x%08x d7 = 0x%08x a0 = 0x%08x",
    			sp->d6, sp->d7, sp->a0);
    syslog(LOG_EMERG, "a2 = 0x%08x a3 = 0x%08x a3 = 0x%08x",
    			sp->a1, sp->a2, sp->a3);
    syslog(LOG_EMERG, "a4 = 0x%08x a5 = 0x%08x a6 = 0x%08x",
    			sp->a4, sp->a5, sp->a6);
    			/*  OÕX^bN|C^̒l  */
    syslog(LOG_EMERG, "a7 = 0x%08x", (sp->a7)+2*4);

    while(1);
}

