/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by KURUSUGAWA Electronics Industry Inc, JAPAN
 *  Copyright (C) 2008 by Takahisa Yokota
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: cpu_config.h,v 1.14 2003/07/08 14:57:12 hiro Exp $
 */

/*
 *	vZbTˑW[iCFV2pj
 *
 *  ̃CN[ht@ĆCt_config.h ݂̂CN[hD
 *  ̃t@C璼ڃCN[hĂ͂ȂȂD
 */

#ifndef _CPU_CONFIG_H_
#define _CPU_CONFIG_H_

/*
 *  J[l̓ʖ̃l[
 */
#include <cpu_rename.h>

/*
 *  lf[^񉻗p}N̒`
 */
#include <util.h>

/*
 *  [U[`
 */
#include <user_config.h>

/*
 *  ݒ\ȍōDx
 */
#ifdef GDB_STUB
#define MAX_IPM  0x6	/* X^ȕꍇ͗Dx6CPUbN   */
#else
#define MAX_IPM  0x7	/* X^uȂ̏ꍇ͍ōDxCPUbN */
#endif /*  GDB_STUB  */

#define str_MAX_IPM  		TO_STRING(MAX_IPM)

/*
 *  vZbT̓ꖽ߂̃CC֐`
 */
#ifndef _MACRO_ONLY
#include <cpu_insn.h>
#endif /* _MACRO_ONLY */

/*
 *  chg_ipm/get_ipm T|[g邩ǂ̒`
 */
#define	SUPPORT_CHG_IPM

/*
 *  TCB ̃tB[h̃rbg̒`
 *
 *  cpu_context.h ɓGKgCQƂ̈ˑ̊֌WŁC
 *  cpu_context.h ɂ͓ȂD
 */
#define	TBIT_TCB_TSTAT		8	/* tstat tB[h̃rbg */
#define	TBIT_TCB_PRIORITY	8	/* priority tB[h̃rbg */

#ifndef _MACRO_ONLY
/*
 *  ^XNReLXgubN̒`
 */
typedef struct task_context_block {
	VP	msp;		/* X^bN|C^ */
	FP	pc;		/* vOJE^ */
} CTXB;

/*
 *  ݃}XN색Cu
 *
 *  ݃}XNiintmaskj́CIPMiInterrupt Priority Maskj8rbg
 *  ɃVtĝłD
 */

/*
 *  ݂̊݃}XN̓Ǐo
 */
Inline UH
current_intmask()
{
	return(current_sr() & 0x0700);
}

/*
 *  ݃}XN̐ݒ
 */
Inline void
set_intmask(UH intmask)
{
	set_sr((current_sr() & ~0x0700) | intmask);
}

/*
 *  ݁^CPUOlXgJE^
 */
extern UW	intnest;

/*
 *  VXeԎQ
 */

Inline BOOL
sense_context()
{
	return(intnest > 0);
}

Inline BOOL
sense_lock()
{
	return(current_intmask() == (MAX_IPM << 8));
}

#define t_sense_lock	sense_lock
#define i_sense_lock	sense_lock

/*
 *  CPUbNƂ̉i^XNReLXgpj
 *
 *  task_intmask ́Cchg_ipm T|[g邽߂̕ϐDchg_ipm T|[
 *  gȂꍇɂ́Ctask_intmask  0 ɂȂĂƍl΂悢D
 */

#ifdef SUPPORT_CHG_IPM
extern UH	task_intmask;	/* ^XNReLXgł̊݃}XN */
#endif /* SUPPORT_CHG_IPM */

Inline void
t_lock_cpu()
{
	disint();
}

Inline void
t_unlock_cpu()
{
#ifdef SUPPORT_CHG_IPM
	/*
	 *  t_unlock_cpu Ăяô CPUbNԂ݂̂ł邽
	 *  ߁C̓r task_intmask 邱Ƃ͂ȂD
	 */
	set_intmask(task_intmask);
#else /* SUPPORT_CHG_IPM */
	enaint();
#endif /* SUPPORT_CHG_IPM */
}

/*
 *  CPUbNƂ̉i^XNReLXgpj
 */

extern UH	int_intmask;	/* ^XNReLXgł̊݃}XN */

Inline void
i_lock_cpu()
{
	UH	intmask;

	/*
	 *  ꎞϐ intmask gĂ̂́Ccurrent_intmask() 
	 *  񂾒Ɋ݂CNꂽ݃nh
	 *  int_intmask ύX\邽߂łD
	 */
	intmask = current_intmask();
	disint();
	int_intmask = intmask;
}

Inline void
i_unlock_cpu()
{
	set_intmask(int_intmask);
}

/*
 *  ^XNfBXpb`
 */

/*
 *  ōD揇ʃ^XNւ̃fBXpb`icpu_support.Sj
 *
 *  dispatch ́C^XNReLXgĂяoꂽT[rXR[
 *  ŁCCPUbNԂŌĂяoȂ΂ȂȂD
 */
extern void	dispatch(void);

/*
 *  ݂̃ReLXĝĂăfBXpb`icpu_support.Sj
 *
 *  exit_and_dispatch ́CCPUbNԂŌĂяoȂ΂ȂȂD
 */
extern void	exit_and_dispatch(void);

#endif  /* _MACRO_ONLY */

/*
 *  ݃nh^CPUOnh̐ݒ
 */

/*
 *  OxN^e[u̒`
 *  @@}N̐
 *  @@@KERNEL_HAS_A_VECTOR_TABLE
 *  @@@@J[lOxN^e[u
 *  @@@SIO_RESERVED
 *  @@@@VAfoCXfobKɂĎgpĂ
 */
#ifndef _MACRO_ONLY

#ifdef KERNEL_HAS_A_VECTOR_TABLE
extern FP vector_table[];	/*  OxN^e[u  */
#endif /* KERNEL_HAS_A_VECTOR_TABLE */

typedef struct exc_vector_entry {
	FP	exchdr;			/* Onh̋NԒn */
} EXCVE;

/*
 *  ݃nh̐ݒ
 *
 *  xNgԍ inhno ̊݃nh̋NԒn inthdr ɐݒ肷D
 */
Inline void
define_inh(INHNO inhno, FP inthdr)
{
#ifdef GDB_STUB
        Asm("moveq.l #0x8,%%d0;  move.l %0,%%d2; move.l %1,%%d3; trap #0xf"
	    : /* no output */
	    : "r"(inhno), "r"(inthdr)
	    : "%%d0", "%%d2", "%%d3");
#else	/*  GDB_STUB  */

#ifdef KERNEL_HAS_A_VECTOR_TABLE

/* SIO_RESERVED͎gpȂBsys_config.hŃRgɂĂ */
/*#ifdef SIO_RESERVED	*//*  VA荞݂͔  */
/*	if ((inhno != RXI0) && (inhno != TXI0))*/
/*#endif *//* SIO_RESERVED */ 
	vector_table[inhno] = inthdr;

#endif /* KERNEL_HAS_A_VECTOR_TABLE */

#endif	/*  GDB_STUB  */
}

/*
 *  CPUOnh̐ݒ
 *
 *  xNgԍ excno CPUOnh̋NԒn exchdr ɐݒ肷D
 */
Inline void
define_exc(EXCNO excno, FP exchdr)
{
	define_inh(excno, exchdr);
}

/*  Cꃋ[`̊֐̃x𐶐  
 *     kernel_cfg.cŎgp
 */
#define	INT_ENTRY(inthdr)	_kernel_##inthdr##_entry
#define	EXC_ENTRY(exchdr)	_kernel_##exchdr##_entry


/*
 *  ݃nh^CPUOnh̓̋ʕ
 *
 *	ColdFireł́A݂CPUÖقƂǓȂ̂ŁA
 *	̃}Nʂɒ`Ă
 *
 *@@
 *	labelF̃x
 *	inthdrFCꃋ[`̐擪AhX
 *	common_routineFcpu_support.S̕AhX
 *			interrupt_entryF݂̏ꍇ
 *			cpu_exception_entryFCPUȌꍇ
 *
 *@@WX^
 *@@@@d1FݎtSR̃Rs[
 *@@@@a0FCꃋ[`̐擪AhX
 *
 *	݂CPUȎ_
 *	@@ECPUOnhɈ^
 *	@@ECPUOł́AOIPMƓlŊ݂
 *		iCPUOɂAIPMωȂj
 *
 *	@@E݃nh̏ꍇ				
 *	@@  	ݎtɃn[hEFAIPMݒ肷	
 *	@@  	݋ɂ͂IPM̒lp		
 *	@@ECPUOnh̏ꍇ				
 *	@@  	CPUOtIPM̒l͕ωȂ		
 *	@@  	݋ɂCPUOIPM̒lp	
 */
#define	HANDLER_ENTRY_PROC(label, handler, common_routine)		   \
asm(".text								\n"\
"	.align 2							\n"\
"	.global "#label"						\n"\
#label":								\n"\
"	lea.l   -16(%sp), %sp		\n"                                \
"	movem.l %d0-%d1/%a0-%a1, (%sp)	\n" /* XNb`WX^ۑ */ \
				/*  ݋֎~SȐ  		*/ \
"	move.w	%sr,%d1							\n"\
	/*  ݋֎~  						*/ \
	/*     ݂֎~Oɕʂ݂̊ꍇ̒ӓ_ 	*/ \
	/*     cpu_suppourt.Sret_intQ 				*/ \
"	move.l	#("str_MAX_IPM" << 8),%d0	                        \n"\
"	ori.l	#0x00002000,%d0	                                        \n"\
"	move.w	%d0,%sr	                                                \n"\
"	move.l	#"#handler", %a0				                \n"\
"	jbra	_kernel_"#common_routine"        \n" /* Cꃋ[`̐擪AhX*/\
)

/*
 *  ݃nh̓̐}N
 *
 */
#define INTHDR_ENTRY(inthdr)	INTHDR_ENTRY2(INT_ENTRY(inthdr), inthdr)

#define INTHDR_ENTRY2(entry, inthdr)					\
	extern void entry(void);					\
	HANDLER_ENTRY_PROC(entry, inthdr, interrupt_entry)


/*
 *  CPUOnh̓̐}N
 */
#define	EXCHDR_ENTRY(exchdr)	EXCHDR_ENTRY2(EXC_ENTRY(exchdr), exchdr)

#define EXCHDR_ENTRY2(entry, exchdr)					\
	extern void entry(void);					\
	HANDLER_ENTRY_PROC(entry, exchdr, cpu_exception_entry)
	/*
	 *  void entry()͒PȂGg̃xȂ̂ŁA
	 *  ͕tȂ
	 */

/*
 *  CPUO̔̃VXeԂ̎Q
 */

/*
 *  CPUO̔̃ReLXg̎Q
 */
Inline BOOL
exc_sense_context(VP p_excinf)
{
	/* 
	 *  PƔr̂́AݎsCPUO̕
	 *  ݃lXgJE^CNgĂ邽 	
	 *  
	 *  CPUO̓ɕʂCPUO͔ȂƉ
	 *  Ă
	 */
	return(intnest > 0);
}

/*
 *  CPUO̔CPUbNԂ̎Q
 */
Inline BOOL
exc_sense_lock(VP p_excinf)
{
	return((*((UH *) p_excinf) & 0x0700) == 0x0700);
}

/*
 *  vZbTˑ̏
 */
extern void	cpu_initialize(void);

/*
 *  vZbTˑ̏I
 */
extern void	cpu_terminate(void);
/*
 *  L̃Oõ͎X^bN\̒`
 */
typedef struct exc_stack {
	VW	d0;
	VW	d1;
	VW	d2;
	VW	d3;
	VW	d4;
	VW	d5;
	VW	d6;
	VW	d7;
	VW	a0;
	VW	a1;
	VW	a2;
	VW	a3;
	VW	a4;
	VW	a5;
	VW	a6;
	VW	a7;
	VW	sr;	/*  Xe[^XEWX^  	*/
	VW	pc;	/*  vOEJE^  	*/
} EXCSTACK;


/*
 * ÕOo (cpu_config.c, cpu_support.S)
 */
extern void     cpu_experr(EXCSTACK *);

#endif /* _MACRO_ONLY */


/*
 *  OxN^ɐݒ肷ftHg̒l
 *  	ȉ̗OvŃftHgƂ͈قȂOxN^`
 *	ꍇ́Asys_config.hŊY}N`B
 */
#define RESET_VECTOR 	start		/*  ZbgxN^  */
#define INIT_STACK  	STACKTOP	/*  X^bN|C^̏l  */

#define RESERVED_VECTOR	RESET_VECTOR	/*  VXe\̃ZbgxN^  */
					/*  ۂɂ͎gpȂ  */

#ifndef ACC_VECTOR	/*  ANZXG[  */
#define ACC_VECTOR	RESET_VECTOR
#endif /* ACC_VECTOR */

#ifndef ADD_VECTOR	/*  ANZXG[  */
#define ADD_VECTOR	RESET_VECTOR
#endif /* ACC_VECTOR */

#ifndef II_VECTOR	/*  s  */
#define II_VECTOR	RESET_VECTOR
#endif /* II_VECTOR */

#ifndef PV_VECTOR	/*  Xbgs  */
#define PV_VECTOR	RESET_VECTOR
#endif /* SII_VECTOR */

#ifndef CAE_VECTOR	/*  CPUAhXG[  */
#define CAE_VECTOR	RESET_VECTOR
#endif /* CAE_VECTOR */

#ifndef DAE_VECTOR	/*  DMAAhXG[  */
#define DAE_VECTOR	RESET_VECTOR
#endif /* DAE_VECTOR */

#ifndef NMI_VECTOR	/*  NMI  */
#define NMI_VECTOR	RESET_VECTOR
#endif /* NMI_VECTOR */

#endif /* _CPU_CONFIG_H_ */
