/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2002-2004 by Hokkaido Industrial Research Institute, JAPAN
 *  Copyright (C) 2007 by KURUSUGAWA Electronics Technology Inc
 *  Copyright (C) 2008 by Takahisa Yokota
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: hw_serial.h,v 1.9 2003/07/08 14:57:15 hiro Exp $
 */

/*
 *	VAI/OfoCXiSIO/MCFUART)hCoiM52235EVBpj
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

#include <s_services.h>

#ifndef _MACRO_ONLY
#include "mcfuart.h"

/* o̓|[g̐ݒsys_config.c */
/* ݃xN^ԍ̐ݒhw_serial.h */
/* ǗubN̐ݒmcfuart.c */

#ifndef GDB_STUB

#define INHNO_SERIAL	 MCF_UART0
#if TNUM_PORT >= 2
#define INHNO_SERIAL2	 MCF_UART1
#endif /* TNUM_PORT >= 2 */

#else	/*  GDB_STUB  */

#define INHNO_SERIAL	 MCF_UART0

#endif	/*  GDB_STUB  */

/*
 *  SIOhCȍ[`
 */
#define	sio_initialize	mcfuart_initialize

/*
 *  VAI/O|[g̃I[v
 */
Inline SIOPCB *
sio_opn_por(ID siopid, VP_INT exinf)
{
	SIOPCB	*siopcb;
	BOOL	openflag;

        /*
	 *  I[v|[g邩 openflag ɓǂłD
	 */
	openflag = mcfuart_openflag(siopid);

	/*
	 *  foCXˑ̃I[vD
	 */
	siopcb = mcfuart_opn_por(siopid, exinf);

	/*
	 *  VAI/O݂̊݃xݒ肵C}XND
	 */
	if (!openflag) {
            if (siopcb->siopinib->reg_base == (IPSBAR + 0x00000200)) {
                sil_wrb_mem (MCF_INTC_ICR(MCF_INTC0, 13), siopcb->siopinib->int_level);
            } else if (siopcb->siopinib->reg_base == (IPSBAR + 0x00000240)) {
                sil_wrb_mem (MCF_INTC_ICR(MCF_INTC0, 14), siopcb->siopinib->int_level);
            }
        }
	return(siopcb);
}

/*
 *  VAI/O|[g̃N[Y
 */
Inline void
sio_cls_por(SIOPCB *siopcb)
{
	/*
	 *  foCXˑ̃N[YD
	 */
	mcfuart_cls_por(siopcb);

	/*
	 *  VAI/O݂}XND
	 */
        if (siopcb->siopinib->reg_base == (IPSBAR + 0x00000200)) {
          sil_wrb_mem (MCF_INTC_ICR(MCF_INTC0, 13), 0);
        } else if (siopcb->siopinib->reg_base == (IPSBAR + 0x00000240)) {
          sil_wrb_mem (MCF_INTC_ICR(MCF_INTC0, 14), 0);
        }
}

/*
 *  SIO̊݃nh
 */
#define	sio_handler	mcfuart_isr
#if TNUM_PORT >= 2
#define	sio_handler2	mcfuart_isr2
#endif /* TNUM_PORT >= 2 */

/*
 *  VAI/O|[gւ̕M
 */
#define	sio_snd_chr	mcfuart_snd_chr

/*
 *  VAI/O|[g̕M
 */
#define	sio_rcv_chr	mcfuart_rcv_chr

/*
 *  VAI/O|[g̃R[obN̋
 */
#define	sio_ena_cbr	mcfuart_ena_cbr

/*
 *  VAI/O|[g̃R[obN̋֎~
 */
#define	sio_dis_cbr	mcfuart_dis_cbr

/*
 *  VAI/O|[g̑M\R[obN
 */
#define	sio_ierdy_snd	mcfuart_ierdy_snd

/*
 *  VAI/O|[g̎MʒmR[obN
 */
#define	sio_ierdy_rcv	mcfuart_ierdy_rcv

#endif /* _MACRO_ONLY */
#endif /* _HW_SERIAL_H_ */
