/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2007 by KURUSUGAWA Electronics Industry Inc, JAPAN
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́C̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: $
 */

/*
 *  JSP-1.4.2 ȍ~ŕύXꂽ݃nhւ̑Ή
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

/*
 *  fec_inter_init -- ^[Qbgˑ݂̊̏
 */

int
memcmp(const void* s1, const void* s2, int n) {
  char* a1 = (char*)s1;
  char* a2 = (char*)s2;
  
  while (n--)
    if (*a1++ != *a2++)
      return *(a1 - 1) - *(a2 - 1);
  return 0;
}


void*
memset(char *s, int c, int n) 
{
  char* p = s;
  while (n--) {
    *p++=c;
  }
  return s;
}


void*
memcpy(void* dest, void* src, int n) {
  char *p1 = dest;
  const char *p2 = src;
  int i;

  for (i = 0; i < n; i++) {
    *(p1++) = *(p2++);
  }

  return dest;
}

void *
memmove (void *d, void *s, int n)
{
    char *dst = d;
    char *src = s;
    void *ret = dst;

    if (src < dst) {
	src += n;
	dst += n;
	while (n--)
	    *--dst = *--src;
    }
    else if (dst < src)
	while (n--)
	    *dst++ = *src++;
    return ret;
}

#if TKERNEL_PRVER >= 0x1042u	/* JSP-1.4.2 ȍ~ */

/*
 * fec_dis_inter -- ݂֎~B
 */
IPM
fec_dis_inter(void)
{
  IPM	ipm;
  
  syscall(get_ipm(&ipm));
  syscall(chg_ipm(if_fec_handler_intmask));
  return ipm;
}

/*
 *  fec_bus_init -- ^[Qbgˑ̃oX̏
 */

void
fec_bus_init (void)
{
}

/*
 *  fec_inter_init -- ^[Qbgˑ݂̊̏
 */

void
fec_inter_init (void)
{
  int i;
  /* NIC ̊荞݂B*/
  for (i = TBIT_FEC_XINF; i <= TBIT_FEC_BABR; i++) {
    sil_wrb_mem (MCF_INTC_ICR(MCF_INTC0, i), ((FEC_INT_LEVEL) << 3) | (FEC_INT_PRI));
    if (i < 32)
      sil_wrw_mem (MCF_INTC_IMRL(MCF_INTC0), sil_rew_mem(MCF_INTC_IMRL(MCF_INTC0)) & (~(1 << i)));
    else
      sil_wrw_mem (MCF_INTC_IMRH(MCF_INTC0), sil_rew_mem(MCF_INTC_IMRH(MCF_INTC0)) & (~(1 << (i-32))));
  }
}

#endif	/* of #if TKERNEL_PRVER >= 0x1042u */
