/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2002-2004 by Hokkaido Industrial Research Institute, JAPAN
 *  Copyright (C) 2007 by KURUSUGAWA Electronics Industry Inc, JAPAN
 *  Copyright (C) 2008 by Takahisa Yokota
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: sh7615frt.h,v 1.5 2005/07/06 00:45:07 honda Exp $
 */

/*
 *	^C}hCo
 *  FRTgp
 */

#ifndef _MCFPIT_H_
#define _MCFPIT_H_

/*
 *   ^C}ւ̓̓NbN̕ݒ
 *   	f/8ŃJEg
 */
#define TCR_CKS         0x0

/*
 *   ^C}ɋNbNg[kHz]
 *      60MHz/2 = 30MHz
 */
#define	TIMER_CLOCK		(25000)

/*
 *  ^C}l̓\̌^
 */
typedef UH CLOCK;

/*
 *  ^C}l̓\ƃ~bEʕbPʂƂ̕ϊ
 *
 */
#define	TO_CLOCK(nume, deno)	(TIMER_CLOCK * (nume) / (deno))
#define	TO_USEC(clock)		((clock) * 1000 / TIMER_CLOCK)
#define CLOCK_PER_TICK	((CLOCK) TO_CLOCK(TIC_NUME, TIC_DENO))

/*
 *  ݒłő̃^C}iPʂ͓\j
 */
#define	MAX_CLOCK	((CLOCK) 0xffff)

/*
 *  ^C}̌ݒlݔO̒lƂ݂Ȃ̔f
 */
#define	GET_TOLERANCE	100		/* x̌ςliPʂ͓\j */
#define	BEFORE_IREQ(clock) \
		((clock) >= TO_CLOCK(TIC_NUME, TIC_DENO) - GET_TOLERANCE)

/*
 *  WX^̐ݒl
 */
#define MCF_PIT_PCSR_EN   (0x0001u)
#define MCF_PIT_PCSR_RLD  (0x0002u)
#define MCF_PIT_PCSR_PIF  (0x0004u)
#define MCF_PIT_PCSR_PIE  (0x0008u)
#define MCF_PIT_PCSR_OVW  (0x0010u)
#define MCF_PIT_PCSR_DBG  (0x0020u)
#define MCF_PIT_PCSR_DOZE (0x0040u)

/*
 *  Rg[WX^̃AhX
 */
#define MCF_PIT0_PCSR   (VH*)(IPSBAR + 0x00150000)
#define MCF_PIT0_PMR    (VH*)(IPSBAR + 0x00150002)
#define MCF_PIT0_PCNTR  (VH*)(IPSBAR + 0x00150004)


#ifndef _MACRO_ONLY

/*
 *  ^C}X^[g
 */
Inline void
mcf_timer_start ()
{
     sil_wrh_mem (MCF_PIT0_PCSR, sil_reh_mem (MCF_PIT0_PCSR) | MCF_PIT_PCSR_EN);
}

/*
 *  ^C}ꎞ~
 */
Inline void
mcf_timer_stop ()
{
    	/* ^C}~ 	  */
	sil_wrh_mem (MCF_PIT0_PCSR, sil_reh_mem (MCF_PIT0_PCSR) & ~MCF_PIT_PCSR_EN);
}
/*
 *  ^C}ݗṽNA
 *	TCRWX^IMFArbg1ǂݏoɂO
 */
Inline void
mcf_timer_int_clear ()
{
	/* 荞ݗvNA     */
	sil_wrh_mem (MCF_PIT0_PCSR, sil_reh_mem (MCF_PIT0_PCSR));
}


/*
 *  ^C}̋N
 *
 *  ^C}CIȃ^C}ݗv𔭐D
 */
Inline void
mcf_timer_initialize ()
{
	CLOCK cyc = TO_CLOCK (TIC_NUME, TIC_DENO);

	/*
	 *  ^C}֘A̐ݒ
	 */
	mcf_timer_stop ();			/* ^C}~ */
	/* ^C}l̃`FbN */
	assert (cyc <= MAX_CLOCK);
       /*
         *  ^C}݂̊݃xݒ肵CvNAC
         *  }XND
         */
        sil_wrh_mem (MCF_PIT0_PCSR, (VH)(MCF_PIT_PCSR_OVW | MCF_PIT_PCSR_PIF | MCF_PIT_PCSR_RLD));
        sil_wrh_mem (MCF_PIT0_PMR, (VH)CLOCK_PER_TICK);
        sil_wrh_mem (MCF_PIT0_PCNTR,0x0000);
        sil_wrh_mem (MCF_PIT0_PCSR, sil_reh_mem(MCF_PIT0_PCSR) | MCF_PIT_PCSR_PIE);	//荞݋
}

/*
 *  ^C}̒~
 *
 *  ^C}̓~D
 */
Inline void
mcf_timer_terminate ()
{
	/*
	 *  ^C}̓~D
	 */
	mcf_timer_stop();
        mcf_timer_int_clear ();
	/*
	 *  ^C}݂}XNCvNAD
	 */
	sil_wrh_mem (MCF_PIT0_PCSR, sil_reh_mem(MCF_PIT0_PCSR) & ~MCF_PIT_PCSR_PIE);	//荞ݕs
	sil_wrh_mem (MCF_PIT0_PCNTR,0x0000);
	sil_wrh_mem (MCF_PIT0_PMR,0x0000); 
        sil_wrw_mem (MCF_INTC_IMRH(MCF_INTC0), sil_rew_mem(MCF_INTC_IMRH(MCF_INTC0)) | (1 << (TBIT_TT0)));
}

/*
 *  ^C}̌ݒl̓Ǐo
 */
Inline CLOCK
mcf_timer_get_current ()
{
	CLOCK	clk;
        
	clk = TO_CLOCK(TIC_NUME, TIC_DENO) - sil_reh_mem(MCF_PIT0_PCNTR);
	return (clk);
}

/*
 *  ^C}ݗṽ`FbN
 */
Inline BOOL
mcf_timer_fetch_interrupt ()
{
        return (sil_reh_mem (MCF_PIT0_PCSR) & MCF_PIT_PCSR_PIF);
}

#endif /* _MACRO_ONLY */
#endif /* _MCFPIT_H_ */
