/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2002-2004 by Hokkaido Industrial Research Institute, JAPAN
 *  Copyright (C) 2007 by KURUSUGAWA Electronics Industry Inc, JAPAN
 *  Copyright (C) 2008 by Takahisa Yokota
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: mcfuart.c,v 1.3 2005/07/06 00:45:07 honda Exp $
 */

/*
 *   COLDFIREUARTp ȈՃhCo
 */

#include <s_services.h>
#include "mcfuart.h"

/*
 *  VAI/O|[gǗubN̒`
 */
/* o̓|[g̐ݒsys_config.c */
/* ݃xN^ԍ̐ݒhw_serial.h */
/* ǗubN̐ݒmcfuart.c */

#ifndef GDB_STUB

const SIOPINIB siopinib_table[TNUM_PORT] = {
	{IPSBAR + 0x00000200, BRR9600, 0x0, 0x27}, /* UART0 */
#if TNUM_PORT >= 2
	{IPSBAR + 0x00000240, BRR9600, 0x0, 0x27}, /* UART1 */
#endif /* TNUM_PORT >= 2 */
};

#else /* GDB_STUB */

const SIOPINIB siopinib_table[TNUM_PORT] = {
	{IPSBAR + 0x00000200, BRR9600, 0x0, 6}, /* SCIF2 */
};

#endif /* GDB_STUB */

#if defined(TTM)
/*
 *  VAI/O|[gǗubN̒`
 *  @2chT|[gɊgꍇ͏lp̃f[^܂߂
 */
struct sio_port_control_block
{
	VP_INT exinf;				/* g */
	BOOL openflag;				/* I[vς݃tO */
};
#endif
/*
 *  VAI/O|[gǗubÑGA
 */
static SIOPCB siopcb_table[TNUM_PORT];

/*
 *  VAI/O|[gIDǗubNo߂̃}N
 */
#define INDEX_SIOP(siopid)	((UINT)((siopid) - 1))
#define get_siopcb(siopid)	(&(siopcb_table[INDEX_SIOP(siopid)]))

/*
 *  Mł邩H
 */
Inline BOOL
mcfuart_getready (SIOPCB * siopcb)
{
  return (sil_reb_mem((VB *) (siopcb->siopinib->reg_base + MCF_UART_USR)) & MCF_UART_USR_RXRDY);
}

/*
 *  𑗐Mł邩H
 */
Inline BOOL
mcfuart_putready (SIOPCB * siopcb)
{
  /* Wait until space is available in the FIFO */
  return (sil_reb_mem((VB*)(siopcb->siopinib->reg_base + MCF_UART_USR)) & MCF_UART_USR_TXRDY);
}

/*
 *  M̎o
 */
Inline char
mcfuart_getchar (SIOPCB * siopcb)
{
	VB data;
        data = sil_reb_mem ((VB*)(siopcb->siopinib->reg_base + MCF_UART_URB));
	return data;
}

/*
 *  M镶̏
 */
Inline void
mcfuart_putchar (SIOPCB * siopcb, char c)
{
    /* Send the character */
    sil_wrb_mem ((VB*)(siopcb->siopinib->reg_base + MCF_UART_UTB), c);
}

/*
 *  SIOhCȍ[`
 */
void
mcfuart_initialize ()
{
	SIOPCB *siopcb;
	UINT i;
        /*
	 *  VAI/O|[gǗubN̏
	 */
	for (siopcb = siopcb_table, i = 0; i < TNUM_PORT; siopcb++, i++) {
		siopcb->openflag = FALSE;
		siopcb->siopinib = (&siopinib_table[i]);
	}
}

/*
 *  I[vĂ|[g邩H
 */
BOOL
mcfuart_openflag (ID siopid)
{
	return (siopcb_table[siopid -1].openflag);
}

/*
 *  VAI/O|[g̃I[v
 */
SIOPCB *
mcfuart_opn_por (ID siopid, VP_INT exinf)
{
        volatile int i;
	SIOPCB *siopcb = get_siopcb(siopid);
        // M~
  	sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UCR), (VB) (MCF_UART_UCR_MISC_RR));
    	sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UCR), (VB) (MCF_UART_UCR_MISC_RT));
      	sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UCR), (VB) (MCF_UART_UCR_MISC_RRC));

        sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UMR1), 0x93);
        sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UMR2), 0x07);
        sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UCSR), 0xDD);

        sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UBG1), (VB) (siopcb->siopinib->brr >> 8));
    	sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UBG2), (VB) (siopcb->siopinib->brr & 0x00ff));

         /*  ݋  */
        siopcb->imr = (VB)MCF_UART_UIMR_RXRDY;
    	sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UIMR), (VB) (siopcb->imr));

        /*  M  */
  	sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UCR), (VB) (MCF_UART_UCR_TC_EN | MCF_UART_UCR_RC_EN));

	siopcb->exinf = exinf;
        siopcb->openflag = TRUE;
        if (siopcb->siopinib->reg_base == (IPSBAR + 0x00000200)) {  
          sil_wrw_mem ((VW*)MCF_INTC_IMRL(MCF_INTC0), sil_rew_mem((VW*)MCF_INTC_IMRL(MCF_INTC0)) & (~(1 << (TBIT_GP0))));
        } else if (siopcb->siopinib->reg_base == (IPSBAR + 0x00000240)) {
          sil_wrw_mem ((VW*)MCF_INTC_IMRL(MCF_INTC0), sil_rew_mem((VW*)MCF_INTC_IMRL(MCF_INTC0)) & (~(1 << (TBIT_GP1))));
        }
        for (i = 0; i < 1000;i++);
	return (siopcb);
}

/*
 *  VAI/O|[g̃N[Y
 */
void
mcfuart_cls_por (SIOPCB * siopcb)
{
	/*  M֎~  */
  	sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UCSR),
				 (VB) (MCF_UART_UCR_TC_DIS | MCF_UART_UCR_RC_DIS));
	/*  ݋֎~  */
	sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UIMR), 0);
        if (siopcb->siopinib->reg_base == (IPSBAR + 0x00000200)) {    
          sil_wrw_mem (MCF_INTC_IMRL(MCF_INTC0), sil_rew_mem(MCF_INTC_IMRL(MCF_INTC0)) | (1 << TBIT_GP0));
        }  else if (siopcb->siopinib->reg_base == (IPSBAR + 0x00000240)) {
          sil_wrw_mem (MCF_INTC_IMRL(MCF_INTC0), sil_rew_mem(MCF_INTC_IMRL(MCF_INTC0)) | (1 << TBIT_GP1));
        }
	siopcb->openflag = FALSE;
}

/*
 *  VAI/O|[gւ̕M
 */
BOOL
mcfuart_snd_chr (SIOPCB * siopcb, char c)
{
	if (mcfuart_putready (siopcb)) {
		mcfuart_putchar (siopcb, c);
		return (TRUE);
	}
	return (FALSE);
}

/*
 *  VAI/O|[g̕M
 */
INT
mcfuart_rcv_chr (SIOPCB * siopcb)
{
	if (mcfuart_getready (siopcb)) {
		return ((INT) (UB) mcfuart_getchar (siopcb));
	}
	return (-1);
}

/*
 *  VAI/O|[g̃R[obN̋
 */
void
mcfuart_ena_cbr (SIOPCB * siopcb, UINT cbrtn)
{
	switch (cbrtn) {
	case SIO_ERDY_SND:			/* M荞ݗv */
                siopcb->imr |= MCF_UART_UIMR_TXRDY;
		break;
	case SIO_ERDY_RCV:			/* M荞ݗv */
                siopcb->imr |= MCF_UART_UIMR_RXRDY;
		break;
	}
        sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UIMR), siopcb->imr);
}

/*
 *  VAI/O|[g̃R[obN̋֎~
 */
void
mcfuart_dis_cbr (SIOPCB * siopcb, UINT cbrtn)
{
	switch (cbrtn) {
	case SIO_ERDY_SND:			/* M荞ݗv֎~ */
                siopcb->imr &= ~MCF_UART_UIMR_TXRDY;
		break;
	case SIO_ERDY_RCV:			/* M荞ݗv֎~ */
                siopcb->imr &= ~MCF_UART_UIMR_RXRDY;
		break;
	}
        sil_wrb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UIMR), siopcb->imr);
}

/*
 * |[Oɂ镶̑M
 */
void
mcfuart_putc_pol (ID portid, char c)
{
	while (!mcfuart_putready (&siopcb_table[portid - 1]));
	mcfuart_putchar (&siopcb_table[portid - 1], c);
}

/*
 *  VAI/O|[gɑ΂鑗Mݏ
 */
Inline void
mcfuart_isr_siop (SIOPCB * siopcb)
{
	VB uisr = sil_reb_mem ((VB *) (siopcb->siopinib->reg_base + MCF_UART_UISR));
        uisr &= siopcb->imr;
	if ((uisr & MCF_UART_UISR_TXRDY) && mcfuart_putready (siopcb)) {
		/*
		 *  MʒmR[obN[`ĂяoD
		 */
		mcfuart_ierdy_snd (siopcb->exinf);
	}
	else if ((uisr & MCF_UART_UISR_RXRDY) && mcfuart_getready (siopcb)) {
		/*
		 *  MʒmR[obN[`ĂяoD
		 */
		mcfuart_ierdy_rcv (siopcb->exinf);
        }
}

/* 荞݌o */
void
mcfuart_isr (void)
{
  if (siopcb_table[0].openflag) {
    mcfuart_isr_siop (get_siopcb (1));
  }
}

#if TNUM_PORT >= 2
/* 荞݌o */
void
mcfuart_isr2 (void)
{

  if (siopcb_table[1].openflag) {
    mcfuart_isr_siop (get_siopcb (2));
  }
}
#endif
