/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2002-2004 by Hokkaido Industrial Research Institute, JAPAN
 *  Copyright (C) 2007 by KURUSUGAWA Electronics Industry Inc, JAPAN
 *  Copyright (C) 2008 by Takahisa Yokota
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: mcfuart.h,v 1.1 2005/07/06 00:45:07 honda Exp $
 */

/*
 *   COLDFIREUARTp ȈՃhCo
 */

#ifndef _MCFUART_H_
#define _MCFUART_H_

#include <t_config.h>

/*
 *  VAI/O|[gubN
 */
typedef struct sio_port_initialization_block
{
	UW reg_base;				/* WX^̃x[XAhX */
	UH brr;					/* {[[g̐ݒl   */
	UB smr;					/* [hWX^̐ݒl   */
	UB int_level;				/* 荞݃x̐ݒl   */
} SIOPINIB;

/*
 *  VAI/O|[gǗubN
 */
typedef struct sio_port_control_block
{
	const SIOPINIB *siopinib;	/* VAI/O|[gubN */
	VP_INT exinf;				/* g */
	BOOL openflag;				/* I[vς݃tO */
	BOOL getready;				/* M */
	BOOL putready;				/* 𑗐Mł */
	VB   imr;				/* ݃}XN̏ */
} SIOPCB;

/*
 *  Rg[WX^̃AhX̃ItZbg 
 */
#define MCF_UART_UMR1	0x00
#define MCF_UART_UMR2	0x00
#define MCF_UART_USR	0x04
#define MCF_UART_UCSR	0x04
#define MCF_UART_UCR	0x08
#define MCF_UART_URB	0x0c
#define MCF_UART_UTB	0x0c
#define MCF_UART_UIPCR	0x10
#define MCF_UART_UACR	0x10
#define MCF_UART_UISR	0x14
#define MCF_UART_UIMR	0x14
#define MCF_UART_UBG1	0x18
#define MCF_UART_UBG2	0x1c
#define MCF_UART_UIP	0x34
#define MCF_UART_UOP1	0x38
#define MCF_UART_UOP0	0x3c

/*
 *  Rg[WX^̐ݒl
 */
/*  FIFORg[WX^SCFCR̃rbg  */
#define MCF_UART_UCR_RC_MASK  0x03
#define MCF_UART_UCR_RC_EN   0x01
#define MCF_UART_UCR_RC_DIS  0x02
#define MCF_UART_UCR_TC_MASK  0x0C
#define MCF_UART_UCR_TC_EN   0x04
#define MCF_UART_UCR_TC_DIS  0x08
#define MCF_UART_UCR_MISC_MASK 0x70
#define MCF_UART_UCR_MISC_RRC  0x10
#define MCF_UART_UCR_MISC_RR   0x20
#define MCF_UART_UCR_MISC_RT   0x30
#define MCF_UART_UCR_MISC_RE   0x40
#define MCF_UART_UCR_MISC_RBK  0x50
#define MCF_UART_UCR_MISC_SBK  0x60
/*  VARg[WX^UIMR̃rbg  */
#define MCF_UART_UIMR_TXRDY 0x01
#define MCF_UART_UIMR_RXRDY 0x02
#define MCF_UART_UIMR_DB    0x04
/*  VARg[WX^UISR̃rbg  */
#define MCF_UART_UISR_TXRDY 0x01
#define MCF_UART_UISR_RXRDY 0x02
#define MCF_UART_UISR_DB    0x04
/*  VAXe[^XWX^SC1SSR̃rbg  */
#define MCF_UART_USR_RXRDY (0x01)	/* MfB */
#define MCF_UART_USR_FULL  (0x02)	/* FIFOt   */
#define MCF_UART_USR_TXRDY (0x04)	/* MfB */
#define MCF_UART_USR_TEMP  (0x08)	/* gX~b^GveB */
#define MCF_UART_USR_OE    (0x10)	/* I[o[G[ */
#define MCF_UART_USR_RE    (0x20)	/* peBG[ */
#define MCF_UART_USR_FE    (0x40)	/* t[~OG[ */
#define MCF_UART_USR_RB    (0x80)	/* u[NM */

/*
 *  UBG̐ݒ
 */
#define SMR_CKS 	0x0			/*            */
#define BRR9600 	195 			/*  9600 rbg[g    */
#define BRR19200	97			/*  19200 rbg[g    */
#define BRR38400	48			/*  38400 rbg[g    */
#define BRR57600 	32			/*  57600 rbg[g 	*/
#define BRR115200 	16			/*  115200 rbg[g */

/*
 *  R[obN[`̎ʔԍ
 */
#define SIO_ERDY_SND	1u		/* M\R[obN */
#define SIO_ERDY_RCV	2u		/* MʒmR[obN */

/*
 *  SIOhCȍ[`
 */
extern void mcfuart_initialize (void);

/*
 *  I[vĂ|[g邩H
 */
extern BOOL mcfuart_openflag (ID siopid);

/*
 *  VAI/O|[g̃I[v
 */
extern SIOPCB *mcfuart_opn_por (ID siopid, VP_INT exinf);

/*
 *  VAI/O|[g̃N[Y
 */
extern void mcfuart_cls_por (SIOPCB * siopcb);

/*
 *  VAI/O|[gւ̕M
 */
extern BOOL mcfuart_snd_chr (SIOPCB * siopcb, char c);

/*
 *  VAI/O|[g̕M
 */
extern INT mcfuart_rcv_chr (SIOPCB * siopcb);

/*
 *  VAI/O|[g̃R[obN̋
 */
extern void mcfuart_ena_cbr (SIOPCB * siopcb, UINT cbrtn);

/*
 *  VAI/O|[g̃R[obN̋֎~
 */
extern void mcfuart_dis_cbr (SIOPCB * siopcb, UINT cbrtn);

/*
 *  SIO̊݃T[rX[`
 */
extern void mcfuart_isr (void);

/*
 *  VAI/O|[g̑M\R[obN
 */
extern void mcfuart_ierdy_snd (VP_INT exinf);

/*
 *  VAI/O|[g̎MʒmR[obN
 */
extern void mcfuart_ierdy_rcv (VP_INT exinf);

#endif /* _MCFUART_H_ */
