/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2002-2004 by Hokkaido Industrial Research Institute, JAPAN
 *  Copyright (C) 2007 by KURUSUGAWA Electronics Industry Inc, JAPAN
 *  Copyright (C) 2008 by Takahisa Yokota
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: vector_table.c,v 1.3 2005/07/06 00:45:07 honda Exp $
 */

/*
 *	OxN^̒`iCOLDFIREpj
 */

#include "jsp_kernel.h"


#ifdef KERNEL_HAS_A_VECTOR_TABLE

static VP _current_vbr = EXCVT_ORIG;

extern void start(void);		/*  start.S  */
extern void no_reg_exception(void);	/*  cpu_support.S  */

VP
current_vbr()
{
        return _current_vbr;
}

void
set_vbr(VP vbr)
{
        _current_vbr = vbr;
	Asm("movec %0, %%vbr" : : "r"(vbr));
}

FP vector_table [192] = {
	(FP)INIT_STACK,		/*   0:X^bN|C^̏l  */
        RESET_VECTOR,		/*   1:p[IZbg  */
	ACC_VECTOR,		/*   2:ANZXG[      */
  	ADD_VECTOR,		/*   3:AhXG[      */
  	II_VECTOR,		/*   4:ʕs        */
	RESERVED_VECTOR,	/*   5:d zero              */
	RESERVED_VECTOR,        /*   6:\                */
        II_VECTOR,              /*   7:VXe\        */
	RESERVED_VECTOR,	/*   8:pvVXe\        */
        RESERVED_VECTOR,        /*   9:trace               */
	RESERVED_VECTOR,	/*  10:line a emulator     */
	RESERVED_VECTOR,	/*  11:line f emulator     */
	RESERVED_VECTOR,	/*  12:VXe\        */
        RESERVED_VECTOR,        /*  13:VXe\        */
	RESERVED_VECTOR,	/*  14:VXe\        */
	RESERVED_VECTOR,	/*  15:VXe\        */
	RESERVED_VECTOR,	/*  16:VXe\        */
        RESERVED_VECTOR,        /*  17:VXe\        */
	RESERVED_VECTOR,	/*  18:VXe\        */
	RESERVED_VECTOR,	/*  19:VXe\        */
	RESERVED_VECTOR,	/*  20:VXe\        */
        RESERVED_VECTOR,        /*  21:VXe\        */
	RESERVED_VECTOR,	/*  22:VXe\        */
	RESERVED_VECTOR,	/*  23:VXe\        */
	RESERVED_VECTOR,	/*  24:XvAX荞  */
				/*  c̓ftHg̗O  */
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
	no_reg_exception,
};

#endif /* KERNEL_HAS_A_VECTOR_TABLE */

