/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2002 by Monami software, Limited Partners.
 *  Copyright (C) 2008-     by Monami Software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: cpu_defs.h,v 1.1 2004/07/21 02:49:36 monaka Exp $
 */

/*
 *	vZbTɈˑ`ii386pj
 */

#ifndef _CPU_DEFS_H_
#define _CPU_DEFS_H_

#define IA32

#ifndef _MACRO_ONLY

typedef	UINT		EXCNO;		/* CPUOnhԍ */

#define SIL_ENDIAN SIL_ENDIAN_LITTLE

#define SIL_REV_ENDIAN_H(data) ((VH)((((UH)(data) & 0xff) << 8) | (((UH)(data) >> 8) & 0xff)))

#define SIL_REV_ENDIAN_W(data) ((VW)((((UW)(data) & 0xff) << 24) | (((UW)(data) & 0xff00) << 8) | (((UW)(data) >> 8) & 0xff00) | (((UW)(data) >> 24) & 0xff)))

Inline VB sil_reb_iop(VP iop) {
	VB data;
	Asm("inb %%dx, %%al" : "=a"(data) : "d"(iop));
	return data;
}

Inline VH sil_reh_iop(VP iop) {
	VH data;
	Asm("inw %%dx, %%ax" : "=a"(data) : "d"(iop));
	return data;
}

Inline VW sil_rew_iop(VP iop) {
	VW data;
	Asm("inl %%dx, %%eax" : "=a"(data) : "d"(iop));
	return data;
}

#define sil_reh_lep(iop) sil_reh_iop(iop)
#define sil_rew_lep(iop) sil_rew_iop(iop)

Inline VH sil_reh_bep(VP iop) {
	return SIL_REV_ENDIAN_H(sil_reh_iop(iop));
}

Inline VW sil_rew_bep(VP iop) {
	return SIL_REV_ENDIAN_W(sil_rew_iop(iop));
}

Inline void sil_wrb_iop(VP iop, VB data) {
	Asm("outb %%al, %%dx" : : "a"(data), "d"(iop));
}

Inline void sil_wrh_iop(VP iop, VH data) {
	Asm("outw %%ax, %%dx" : : "a"(data), "d"(iop));
}

Inline void sil_wrw_iop(VP iop, VW data) {
	Asm("outl %%eax, %%dx" : : "a"(data), "d"(iop));
}

#define sil_wrh_lep(iop, data) sil_wrh_iop(iop, data)
#define sil_wrw_lep(iop, data) sil_wrw_iop(iop, data)

Inline void sil_wrh_bep(VP iop, VH data) {
	sil_wrh_iop(iop, SIL_REV_ENDIAN_H(data));
}

Inline void sil_wrw_bep(VP iop, VW data) {
	sil_wrw_iop(iop, SIL_REV_ENDIAN_W(data));
}

#endif /* _MACRO_ONLY */
#endif /* _CPU_DEFS_H_ */
