/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2002 by Monami software, Limited Partners.
 *  Copyright (C) 2002 by MURANAKA Masaki
 *  Copyright (C) 2008-     by Monami Software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: hw_serial.h,v 1.1 2004/07/21 02:49:36 monaka Exp $
 */

/*
 *	^[QbgˑVAI/OW[iPC/ATpj
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

#include <s_services.h>
#include <irc.h>
#include <pcat_com.h>

/*
 *  VAI/O̊݃nh̃xN^ԍ
 */
#define INHNO_SIO1	 PCAT_COM1_INHNO
#if TNUM_PORT >= 2
#define INHNO_SIO2	 PCAT_COM2_INHNO
#endif

#ifndef _MACRO_ONLY

/*
 *  VAI/O|[g̏
 */
#define sio_initialize pcat_com_initialize

#define sio1_handler pcat_com1_handler
#if TNUM_PORT >= 2
#define sio2_handler pcat_com2_handler
#endif

Inline SIOPCB *
sio_opn_por(ID portid, VP_INT spcb)
{
  SIOPCB *p;

  p = pcat_com_opn_por(portid, spcb);

  irc_ena_irq(p->siopinib->com_irq);

  return p;
}

/*
 *  VAI/O|[g̏I
 */
Inline void
sio_cls_por(SIOPCB *p)
{
	pcat_com_cls_por(p);
  irc_dis_irq(p->siopinib->com_irq);
}

#define sio_ierdy_rcv pcat_com_ierdy_rcv

#define sio_ierdy_snd pcat_com_ierdy_snd

/*
 *  M̎o
 */
#define sio_rcv_chr pcat_com_rcv_chr

/*
 *  M镶̏
 */
#define sio_snd_chr pcat_com_snd_chr

#define sio_ena_cbr pcat_com_ena_cbr

#define sio_dis_cbr pcat_com_dis_cbr

#endif /* _MACRO_ONLY */

#endif /* _HW_SERIAL_H_ */
