/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2002 by Monami software, Limited Partners.
 *  Copyright (C) 2002 by MURANAKA Masaki
 *  Copyright (C) 2008-     by Monami Software Limited Partnership, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id$
 */

/*
 *	COMhCoiPC/ATpj
 */

#include <s_services.h>
#include <pcat_com.h>

#define PCAT_COM_IIR_RLS (0x06)
#define PCAT_COM_IIR_RXD (0x04)
#define PCAT_COM_IIR_TXD (0x02)

#define PCAT_COM_IER_LS (4)
#define PCAT_COM_IER_TX (2)
#define PCAT_COM_IER_RX (1)

#define PCAT_COM_RBR 0
#define PCAT_COM_THR 0
#define PCAT_COM_DLL 0
#define PCAT_COM_IER 1
#define PCAT_COM_DLM 1
#define PCAT_COM_IIR 2
#define PCAT_COM_FCR 2
#define PCAT_COM_LCR 3
#define PCAT_COM_MCR 4
#define PCAT_COM_LSR 5
#define PCAT_COM_MSR 6
#define PCAT_COM_SCR 7

#define PCAT_COM_DIVISOR_LATCH(a) (24000000 / 13 / 16 / (a))

#ifndef PCAT_COM1_BAUD_RATE
#define PCAT_COM1_BAUD_RATE 9600
#endif
#if TNUM_SIOP >= 2
#ifndef PCAT_COM2_BAUD_RATE
#define PCAT_COM2_BAUD_RATE 9600
#endif
#endif

/*
 *  ჌x|[gǗubN̏l
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {
	{
		PCAT_COM1_BASE,
		TO_INTNO(PCAT_COM1_INHNO),
		PCAT_COM_DIVISOR_LATCH(PCAT_COM1_BAUD_RATE)
	},
#if TNUM_SIOP >= 2
	{
		PCAT_COM2_BASE,
		TO_INTNO(PCAT_COM2_INHNO),
		PCAT_COM_DIVISOR_LATCH(PCAT_COM2_BAUD_RATE)
	},
#endif
};
SIOPCB siopcb_table[TNUM_SIOP];

Inline UB pcat_com_read(UH base, UH offset) {
	return sil_reb_iop((VP)(base + offset));
}

Inline void pcat_com_write(UH base, UH offset, UB data) {
	sil_wrb_iop((VP)(base + offset), data);
}

/*
 *  MH
 */
Inline BOOL
hw_port_getready(SIOPCB *p)
{
  UB stat;
  stat = pcat_com_read(p->siopinib->base_address, PCAT_COM_LSR);

  return ((stat & 0x01) != 0);
}

/*
 *  𑗐Mł邩H
 */
Inline BOOL
hw_port_putready(SIOPCB *p)
{
  UB stat;
  stat = pcat_com_read(p->siopinib->base_address, PCAT_COM_LSR);

  return ((stat & 0x20) != 0);
}

SIOPCB *
pcat_com_set_mode(ID portid) {
  SIOPCB *p;

  p = &(siopcb_table[portid - 1]);
	if (p->initflag) {
		return p;
	}
  pcat_com_write(p->siopinib->base_address, PCAT_COM_IER, 0); // Disable interrupt.
  pcat_com_write(p->siopinib->base_address, PCAT_COM_LCR, 0x83); // DLAB=1, 8bit, stop=1, Non parity.
  pcat_com_write(p->siopinib->base_address, PCAT_COM_DLL, (UB)p->siopinib->divisor_latch);
  pcat_com_write(p->siopinib->base_address, PCAT_COM_DLM, (UB)(p->siopinib->divisor_latch >> 8));
  pcat_com_write(p->siopinib->base_address, PCAT_COM_LCR, 0x03); // DLAB=0, 8bit, stop=1, Non parity.
  pcat_com_write(p->siopinib->base_address, PCAT_COM_FCR, 0x07);  // Enable FIFO.


  pcat_com_read(p->siopinib->base_address, PCAT_COM_LSR);
  pcat_com_read(p->siopinib->base_address, PCAT_COM_RBR);
  pcat_com_read(p->siopinib->base_address, PCAT_COM_IIR);
  pcat_com_read(p->siopinib->base_address, PCAT_COM_MCR);

  p->initflag = TRUE;			/* tOݒ */

  return p;
}

void pcat_com_isr(VP_INT exinf) {
	SIOPCB *p = (SIOPCB *)exinf;
	while (1) {
		switch (pcat_com_read(p->siopinib->base_address, PCAT_COM_IIR) & 7) {
		case PCAT_COM_IIR_TXD:
			pcat_com_ierdy_snd(p->spcb);
			break;
		case PCAT_COM_IIR_RXD:
			pcat_com_ierdy_rcv(p->spcb);
			break;
		case PCAT_COM_IIR_RLS:
			pcat_com_read(p->siopinib->base_address, PCAT_COM_LSR);
			break;
		default:
			return;
		}
	}
}

void
pcat_com_initialize()
{
	UINT i;
	for (i = 0; i < TNUM_SIOP; ++i) {
		siopcb_table[i].siopinib = &siopinib_table[i];
	}
}

/*
 *  VAI/O|[g̊݃nh
 */
void
pcat_com1_handler()
{
	pcat_com_isr(&siopcb_table[0]);
}
#if TNUM_PORT >= 2
void
pcat_com2_handler()
{
	pcat_com_isr(&siopcb_table[1]);
}
#endif

SIOPCB *
pcat_com_opn_por(ID portid, VP_INT spcb)
{
  SIOPCB *p;

  p = pcat_com_set_mode(portid);
  p->spcb = spcb;

  pcat_com_write(p->siopinib->base_address, PCAT_COM_MCR, 0x0b); // Enable OUT2 interrupt.

  return p;
}

/*
 *  VAI/O|[g̏I
 */
void
pcat_com_cls_por(SIOPCB *p)
{
    
  p->initflag = FALSE;
  pcat_com_write(p->siopinib->base_address, PCAT_COM_IER, 0); // Disable interrupt.
}

/*
 *  M̎o
 */
INT
pcat_com_rcv_chr(SIOPCB *p)
{
  UB ch;
  
	if (!hw_port_getready(p)) {
		return -1;
	}
  ch = pcat_com_read(p->siopinib->base_address, PCAT_COM_RBR);
  return (INT)ch;
}

/*
 *  M镶̏
 */
BOOL
pcat_com_snd_chr(SIOPCB *p, char c)
{
  if (!hw_port_putready(p)) {
    return FALSE;
  }
  pcat_com_write(p->siopinib->base_address, PCAT_COM_THR, c);
  return TRUE;
}

void
pcat_com_ena_cbr(SIOPCB *siopcb, UINT cbrtn)
{
	UB ier = pcat_com_read(siopcb->siopinib->base_address, PCAT_COM_IER);
	if (cbrtn == SIO_ERDY_SND) {
		ier |= PCAT_COM_IER_TX;
	} else if (cbrtn == SIO_ERDY_RCV) {
		ier |= PCAT_COM_IER_LS | PCAT_COM_IER_RX;
	}
	pcat_com_write(siopcb->siopinib->base_address, PCAT_COM_IER, ier);
}

void
pcat_com_dis_cbr(SIOPCB *siopcb, UINT cbrtn)
{
	UB ier = pcat_com_read(siopcb->siopinib->base_address, PCAT_COM_IER);
	if (cbrtn == SIO_ERDY_SND) {
		ier &= ~PCAT_COM_IER_TX;
	} else if (cbrtn == SIO_ERDY_RCV) {
		ier &= ~(PCAT_COM_IER_LS | PCAT_COM_IER_RX);
	}
	pcat_com_write(siopcb->siopinib->base_address, PCAT_COM_IER, ier);
}

void pcat_com_init(ID siopid) {
	pcat_com_initialize();
	pcat_com_set_mode(siopid);
}

void pcat_com_putc(ID siopid, char c) {
	SIOPCB *p;
	p = &siopcb_table[siopid - 1];
	while (!pcat_com_snd_chr(p, c)) {
	}
}
