/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: cpu_config.h,v 1.14 2007/07/27 11:28:44 honda Exp $
 */

#ifndef _CPU_CONFIG_H_
#define _CPU_CONFIG_H_

#include "cpu_defs.h"

#ifndef _MACRO_ONLY
#include <cpu_insn.h>
#endif

#ifndef _MACRO_ONLY

extern UW exception_count;
extern UW exception_registers[40];

typedef struct task_context_block {
        VP	sp;             
        FP	pc;             
} CTXB;


Inline BOOL
sense_context()
{
    return(exception_count > 0);
}

Inline BOOL
sense_lock()
{
    return((current_sr() & 0x1) == 0);
}

#define t_sense_lock     sense_lock
#define i_sense_lock     sense_lock

Inline void
lock_cpu()
{
    disint();
}

Inline void
unlock_cpu()
{
    enaint();
}

#define EXC_ENTRY(exchdr)     exchdr
#define EXCHDR_ENTRY(exchdr)  extern void exchdr(VP sp)

Inline BOOL
exc_sense_context(VP p_excinf)
{
    return(exception_count > 1);
}

Inline BOOL
exc_sense_lock(VP p_excinf)
{
	return((current_sr() & 0x2) == 0);
}


#define t_lock_cpu      lock_cpu
#define i_lock_cpu      lock_cpu
#define t_unlock_cpu    unlock_cpu
#define i_unlock_cpu    unlock_cpu

extern void dispatch(void);
extern void exit_and_dispatch(void);

extern FP int_table[TMAX_ALL_INTNO];
extern FP exc_table[TMAX_CORE_EXCNO];

Inline void define_inh(INTNO intno, FP inthdr)
{
    int_table[intno] = inthdr;
}

Inline void define_exc(EXCNO excno, FP exchdr)
{
    exc_table[excno] = exchdr;
}

extern void _start();
extern void Breakpoint_exception();
extern void InstructionBusError_exception();
extern void Watchpoint_exception();
extern void DataBusError_exception();
extern void DivideByZero_exception();
extern void Interrupt_exception();
extern void SystemCall_exception();

extern void cpu_initialize(void);
extern void cpu_terminate(void);

#endif /* _MACRO_ONLY */

#endif /* _CPU_CONFIG_H_ */

