/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: hw_timer.h,v 1.14 2007/07/27 11:28:44 honda Exp $
 */

#ifndef _HW_TIMER_H_
#define _HW_TIMER_H_

#include <s_services.h>
#include <lm32.h>

#ifndef _MACRO_ONLY

typedef UW    CLOCK;

#define TO_CLOCK(nume, deno) (TIMER_CLOCK * (nume) / (deno))
#define TO_USEC(clock)       ((clock) * 1000 / TIMER_CLOCK)

#define MAX_CLOCK    ((CLOCK) 0xffffffff)

#define GET_TOLERANCE    100
#define BEFORE_IREQ(clock) \
        ((clock) >= TO_CLOCK(TIC_NUME, TIC_DENO) - GET_TOLERANCE)

#define CLOCK_PER_TICK		((CLOCK) TO_CLOCK(TIC_NUME, TIC_DENO))

Inline void
hw_timer_initialize()
{
	UW sr;
		
    sil_wrw_mem((VP)TIMER_CONTROL, TIMER_CONTROL_STOP);
    sil_wrw_mem((VP)TIMER_STATUS, 0);
    
    sil_wrw_mem((VP)TIMER_PERIOD, CLOCK_PER_TICK);

    Asm("rcsr %0, im" : "=r"(sr));
    sr |= (1 << INHNO_TIMER);
    Asm("wcsr im, %0" : : "r"(sr) );
    
    sil_wrw_mem((VP)TIMER_CONTROL, 
        TIMER_CONTROL_ITO | TIMER_CONTROL_CONT | TIMER_CONTROL_START);
        
}

Inline void
hw_timer_int_clear()
{
    sil_wrw_mem((VP)TIMER_STATUS, 0);
}

Inline void
hw_timer_terminate()
{
    sil_wrw_mem((VP)TIMER_CONTROL, TIMER_CONTROL_STOP);
    sil_wrw_mem((VP)TIMER_STATUS, 0);
}

Inline CLOCK
hw_timer_get_current(void)
{
    return(CLOCK_PER_TICK - sil_rew_mem((VP)TIMER_SNAPSHOT));
}

Inline BOOL
hw_timer_fetch_interrupt(void)
{
    return(sil_rew_mem((VP)TIMER_STATUS) & TIMER_STATUS_TO);
}
#endif /* _MACRO_ONLY */
#endif /* _HW_TIMER_H_ */
