/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2002-2004 by Hokkaido Industrial Research Institute, JAPAN
 *  Copyright (C) 2010 by Cronus Computer Works, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id
 */

#include "jsp_kernel.h"
#include <sil.h>
#include <s_services.h>
#include "sh726xscif.h"

/*
 *  ^[QbgVXeˑ̏
 */
/*
 *  VAI/O|[g̏ bannero͂̂߃J[l̏Ɩ֌Wɍs
 */
void
sys_initialize ()
{
	SIOPCB *siopcb;

	/* gpӋ@͂ŗLɂĂB */
	/*  SCIFf[^o̓|[g̐ݒ  */

#ifndef GDB_STUB

	/* SCIF2 */
	sil_wrb_mem (STBCR4, (VB) ((VB) sil_reb_mem (STBCR4) & ~0x20));
	sil_wrh_mem (PFCR0, sil_reh_mem (PFCR0) | (0x0400 | 0x0040));
#if TNUM_PORT >=2
	/* SCIF3 */
	sil_wrb_mem (STBCR4, (VB) ((VB) sil_reb_mem (STBCR4) & ~0x10));
	sil_wrh_mem (PFCR1, sil_reh_mem (PFCR1) | 0x0004);
	sil_wrh_mem (PFCR0, sil_reh_mem (PFCR0) | 0x4000);
#endif /*TNUM_PORT >=2 */

#else /* GDB_STUB */

	/* SCIF3 */
	sil_wrb_mem (STBCR4, (VB) ((VB) sil_reb_mem (STBCR4) & ~0x10));
	sil_wrh_mem (PFCR1, sil_reh_mem (PFCR1) | 0x0004);
	sil_wrh_mem (PFCR0, sil_reh_mem (PFCR0) | 0x4000);

#endif /* GDB_STUB */

	/* CMT0 */
	sil_wrb_mem (STBCR7, (VB) ((VB) sil_reb_mem (STBCR7) & ~0x04));
	/*
	 *  foCXˑ̃I[vD
	 */
	/*oi[o͂邽 */
	sh2scif_initialize();
	siopcb = sh2scif_opn_por (LOGTASK_PORTID, 0);
}

/*
 *  ^[QbgVXȅI
 */
void
sys_exit ()
{
	sh2_exit ();
}

/*
 *  ^[QbgVXe̕o
 */
void
sys_putc (char c)
{
	if (c == '\n') {
		sh2_putc (LOGTASK_PORTID, '\r');
	}
	sh2_putc (LOGTASK_PORTID, c);
}

/* n[hEFA̐ݒ */
/* ł̓oX̐ݒ̂ݍsBӋ@̐ݒsys_initializeōsB */
#ifndef GDB_STUB
void
hardware_init_hook (void)
{
	/* NbNȔ */
	sil_wrh_mem (FRQCR, 0x1104);	/* NbNݒ I=144MHz, B=48MHz, P=24MHz */

	/* I/O|[g̐ݒ */
	sil_wrh_mem (PCIOR0, 0x0100);	/* PC8|[g o͕ (LEDڑ|[g) */
	sil_wrh_mem (PCCR2, 0x0000);	/* PC8[h |[gI (LEDڑ|[g) */

	/* LbV̐ݒ */
	sil_wrw_mem (CCR1, 0x00000808);	/* LbVtbV */
	sil_wrw_mem (CCR1, CCR_MODE);	/* LbV[hݒ */
}
#else /*  GDB_STUB  */
void
hardware_init_hook (void)
{
}
#endif /*  GDB_STUB  */
