/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2002-2004 by Hokkaido Industrial Research Institute, JAPAN
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id$
 */

/*
 *  CPUˑ^C}W[iSH7047pj
 *  CMT0gp
 *
 */

#ifndef _HW_TIMER_H_
#define _HW_TIMER_H_

#include <s_services.h>
#include "crb_h3.h"

/*
 *  RyA}b`^C}X^[gWX^CMSTR̃rbgݒ
 */
#define CMSTR_STR1	0x0002	/* JEgX^[g1 */
#define CMSTR_STR0  0x0001	/* JEgX^[g0 */

/*
 *  RyA}b`^C}Rg[^Xe[^XWX^CMCSR̃rbgݒ
 */
#define CMCSR_CMF   0x0080	/* RyA}b`tO */
#define CMCSR_CMIE  0x0040	/* RyA}b`݃Cl[u */
#define CMCSR_CKS8  0x0000	/* 8NbNZNg */

/*
 *  ^C}݃nh̃xN^ԍ
 */
#define	INHNO_TIMER	CMI0

/*
 *   ^C}ɋNbNg[kHz]
 *   	40.000MHz/8 =5.0000MHz =5000.0kHz
 */
#define TIMER_CLOCK     (CLOCK_RATE/8000L)

#ifndef _MACRO_ONLY
/*
 *  ^C}l̓\̌^
 */
typedef UH CLOCK;

/*
 *  ^C}l̓\ƃ~bEʕbPʂƂ̕ϊ
 *
 */
#define	TO_CLOCK(nume, deno)	(TIMER_CLOCK * (nume) / (deno))
#define	TO_USEC(clock)		((clock) * 1000 / TIMER_CLOCK)
#define CLOCK_PER_TICK	((CLOCK) TO_CLOCK(TIC_NUME, TIC_DENO))

/*
 *  ݒłő̃^C}iPʂ͓\j
 */
#define	MAX_CLOCK	((CLOCK) 0xffff)

/*
 *  ^C}̌ݒlݔO̒lƂ݂Ȃ̔f
 */
#define	GET_TOLERANCE	100		/* x̌ςliPʂ͓\j */
#define	BEFORE_IREQ(clock) \
		((clock) >= TO_CLOCK(TIC_NUME, TIC_DENO) - GET_TOLERANCE)


/*  ݃xݒ背WX^ɑƂ̃Vtg  */
#define FRT_BIT_SHIFT	4

/*
 *  ^C}̋N
 *
 *  ^C}CIȃ^C}ݗv𔭐D
 */
Inline void
hw_timer_initialize()
{
	/* ^C}foCX̂̏ */
	sil_wrh_mem((VP)IOREG_CMSTR_BASE, 0x0000);	/* ^C}Xgbv */
												/* JE^lݒ */
	sil_wrh_mem((VP)(IOREG_CMT0_BASE+IOREG_CMCOR_OFFSET), TO_CLOCK(TIC_NUME, TIC_DENO));

	/* 荞݃xݒ   */
	define_int_plevel ((VH*)(IOREG_INTC_BASE+IOREG_IPRG_OFFSET), TIMER_INTLVL, FRT_BIT_SHIFT);

	/*  ݐݒƗvNAƃNbNZbg */
	sil_wrh_mem((VP)(IOREG_CMT0_BASE+IOREG_CMCSR_OFFSET), (CMCSR_CMIE|CMCSR_CKS8));
	sil_wrh_mem((VP)IOREG_CMSTR_BASE, CMSTR_STR0);	/* ^C}X^[g */
}

/*
 *  ^C}ݗṽNA
 */
Inline void
hw_timer_int_clear()
{
	sil_wrh_mem((VP)(IOREG_CMT0_BASE+IOREG_CMCSR_OFFSET),
		(sil_reh_mem((VP)(IOREG_CMT0_BASE+IOREG_CMCSR_OFFSET)) & ~CMCSR_CMF));
}

/*
 *  ^C}̒~
 *
 *  ^C}̓~D
 */
Inline void
hw_timer_terminate()
{
	sil_wrh_mem((VP)IOREG_CMSTR_BASE,			/* ^C}̒~ */
		(sil_reh_mem((VP)IOREG_CMSTR_BASE) & ~CMSTR_STR0));
	sil_wrh_mem((VP)(IOREG_CMT0_BASE+IOREG_CMCSR_OFFSET), CMCSR_CKS8);/* ݒ~ƗṽNA */
}

/*
 *  ^C}̌ݒl̓Ǐo
 *@@@^C}̓ꎞIɒ~C^C}lǂݏoD
 */
Inline CLOCK
hw_timer_get_current(void)
{
	return sil_reh_mem((VP)(IOREG_CMT0_BASE+IOREG_CMCNT_OFFSET));
}

/*
 *  ^C}ݗṽ`FbN
 */
Inline BOOL
hw_timer_fetch_interrupt(void)
{
	return ((sil_reh_mem((VP)(IOREG_CMT0_BASE+IOREG_CMCSR_OFFSET)) & CMCSR_CMIE) != 0);
}

#endif /* _MACRO_ONLY */
#endif /* _HW_TIMER_H_ */
