/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2002-2004 by Hokkaido Industrial Research Institute, JAPAN
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id$
 */

/*
 *  SH7047VAR~jP[VC^[tFCXSCIp ȈՃhCo
 */

#include <s_services.h>
#include "sh7047.h"
#include "sh7047scif.h"

/*
 *  VAI/O|[gubN
 */
static const SIOPINIB siopinib_table[TNUM_PORT] = {
	{
		(IOREG_SCI_BASE+IOREG_SCI_WINDOW*1),
		(IOREG_INTC_BASE+IOREG_IPRI_OFFSET),
		9,
		ISR_SCR3_SHIFT
	},
	{
		(IOREG_SCI_BASE+IOREG_SCI_WINDOW*2),
		(IOREG_INTC_BASE+IOREG_IPRI_OFFSET),
		8,
		ISR_SCR4_SHIFT
	}
};

/*
 *  VAI/O|[gǗubÑGA
 *      ID = 1 SCI3ɑΉĂ.
 */
SIOPCB siopcb_table[TNUM_PORT];

/*
 *  VAI/O|[gIDǗubNo߂̃}N
 */
#define INDEX_SIOP(siopid)	((UINT)((siopid) - 1))
#define get_siopcb(siopid)	(&(siopcb_table[INDEX_SIOP(siopid)]))

/*
 *  Mł邩H
 */
Inline BOOL
sh7047scif_getready (SIOPCB * siopcb)
{
	/* V[uf[^WX^tEtÕ`FbN */
	return (sil_reb_mem((VP)(siopcb->siopinib->cntrl+IOREG_SSR_OFFSET)) & SSR_RDRF);
}

/*
 *  𑗐Mł邩H
 */
Inline BOOL
sh7047scif_putready (SIOPCB * siopcb)
{
	/* gX~bgFIFOf[^WX^GveBEtÕ`FbN */
	return (sil_reb_mem((VP)(siopcb->siopinib->cntrl+IOREG_SSR_OFFSET)) & SSR_TDRE);
}

/*
 *  M̎o
 */
Inline char
sh7047scif_getchar (SIOPCB * siopcb)
{
	VB data;

	data = sil_reb_mem((VP)(siopcb->siopinib->cntrl+IOREG_RDR_OFFSET));
	/* V[uf[^WX^tEtÕNA */
	sil_wrb_mem((VP)(siopcb->siopinib->cntrl+IOREG_SSR_OFFSET),
		sil_reb_mem((VP)(siopcb->siopinib->cntrl+IOREG_SSR_OFFSET)) & ~SSR_RDRF);
	return data;
}

/*
 *  M镶̏
 */
Inline void
sh7047scif_putchar (SIOPCB * siopcb, char c)
{
	sil_wrb_mem((VP)(siopcb->siopinib->cntrl+IOREG_TDR_OFFSET), c);
	/* gX~bgFIFOf[^WX^GveBEtÕNA */
	sil_wrb_mem((VP)(siopcb->siopinib->cntrl+IOREG_SSR_OFFSET),
		sil_reb_mem((VP)(siopcb->siopinib->cntrl+IOREG_SSR_OFFSET)) & ~SSR_TDRE);
}

/*
 *  SIOhCȍ[`
 */
void
sh7047scif_initialize ()
{
	SIOPCB *siopcb;
	UINT i;

	/*
     *  VAI/O|[gǗubN̏
     */
	for (siopcb = siopcb_table, i = 0; i < TNUM_PORT; siopcb++, i++) {
		siopcb->siopinib = &siopinib_table[i];
		siopcb->openflag = FALSE;
	}
}

/*
 *  I[vĂ|[g͂邩H
 */
BOOL
sh7047scif_openflag (ID siopid)
{
	if(siopcb_table[INDEX_SIOP(siopid)].openflag)
		return TRUE;
	sil_dly_nse(sh2scif_DELAY*4);	/* Wait for Banner */
	return FALSE;
}

/*
 *  VAI/O|[g̃I[v
 */
SIOPCB *
sh7047scif_opn_por (ID siopid, VP_INT exinf)
{
	SIOPCB *siopcb;
	UW     base;
	unsigned char  dummy;

	siopcb = get_siopcb (siopid);
	base   = siopcb->siopinib->cntrl;
	/* M~ */
	sil_wrb_mem((VP)(base+IOREG_SCR_OFFSET),
		 sil_reb_mem((VP)(base+IOREG_SCR_OFFSET)) & ~(SCR_TE | SCR_RE));
	/* [hWX^̐ݒ */
	sil_wrb_mem((VP)(base+IOREG_SMR_OFFSET), DEFAULT_SMR);
	/* {[[g̐ݒ */
	sil_wrb_mem((VP)(base+IOREG_BRR_OFFSET), DEFAULT_BRR);

	sil_dly_nse(sh2scif_DELAY);
	/* MAM݋ */
	sil_wrb_mem((VP)(base+IOREG_SCR_OFFSET), SCR_RIE|SCR_TE|SCR_RE);
	dummy = sil_reb_mem((VP)(base+IOREG_SSR_OFFSET));		/* Dummy read */
	/* ݃Rg[̐ݒ */
	sil_wrb_mem((VP)(base+IOREG_SSR_OFFSET), SSR_TDRE);		/* Clear error flags */
	siopcb->exinf    = exinf;
	siopcb->openflag = TRUE;
	return(siopcb);
}

/*
 *  VAI/O|[g̃N[Y
 */
void
sh7047scif_cls_por (SIOPCB * siopcb)
{
	/* M~A݋֎~ */
	sil_wrb_mem((VP)(siopcb->siopinib->cntrl+IOREG_SCR_OFFSET),
			sil_reb_mem((VP)(siopcb->siopinib->cntrl+IOREG_SCR_OFFSET)) & ~(SCR_TIE|SCR_RIE|SCR_TE|SCR_RE));

	siopcb->openflag = FALSE;
}

/*
 *  VAI/O|[gւ̕M
 */
BOOL
sh7047scif_snd_chr (SIOPCB * siopcb, char c)
{
	if (sh7047scif_putready (siopcb)) {
		sh7047scif_putchar (siopcb, c);
		return (TRUE);
	}
	return (FALSE);
}

/*
 *  VAI/O|[g̕M
 */
INT
sh7047scif_rcv_chr (SIOPCB * siopcb)
{
	if (sh7047scif_getready (siopcb)) {
		return ((INT) (UB) sh7047scif_getchar (siopcb));
	}
	return (-1);
}

/*
 *  VAI/O|[g̃R[obN
 */
void
sh7047scif_ena_cbr (SIOPCB * siopcb, UINT cbrtn)
{
	UW base = siopcb->siopinib->cntrl;

	switch (cbrtn) {
	case SIO_ERDY_SND:		/* Mݗv */
		sil_wrb_mem((VP)(base+IOREG_SCR_OFFSET), sil_reb_mem((VP)(base+IOREG_SCR_OFFSET)) | SCR_TIE);
		break;
	case SIO_ERDY_RCV:		/* Mݗv */
		sil_wrb_mem((VP)(base+IOREG_SCR_OFFSET), sil_reb_mem((VP)(base+IOREG_SCR_OFFSET)) | SCR_RIE);
		break;
	default:
		break;
	}
}

/*
 *  VAI/O|[g̃R[obN֎~
 */
void
sh7047scif_dis_cbr (SIOPCB * siopcb, UINT cbrtn)
{
	UW base = siopcb->siopinib->cntrl;

	switch (cbrtn) {
	case SIO_ERDY_SND:		/* Mݗv֎~ */
		sil_wrb_mem((VP)(base+IOREG_SCR_OFFSET), sil_reb_mem((VP)(base+IOREG_SCR_OFFSET)) & ~SCR_TIE);
		break;
	case SIO_ERDY_RCV:		/* Mݗv֎~ */
		sil_wrb_mem((VP)(base+IOREG_SCR_OFFSET), sil_reb_mem((VP)(base+IOREG_SCR_OFFSET)) & ~SCR_RIE);
		break;
	default:
		break;
	}
}

/*
 *  VAI/O|[gɑ΂鑗Mݏ
 */
Inline void
sh7047scif_isr_siop_out (SIOPCB * siopcb)
{
	VB scr0 = sil_reb_mem((VP)(siopcb->siopinib->cntrl+IOREG_SCR_OFFSET));

	if ((scr0 & SCR_TIE) != 0 && sh7047scif_putready (siopcb)) {
		/*
		 *  MʒmR[obN[`ĂяoD
		 */
		sh7047scif_ierdy_snd (siopcb->exinf);
	}
}

/*
 *  VAI/O|[gɑ΂Mݏ
 */
Inline void
sh7047scif_isr_siop_in (SIOPCB * siopcb)
{
	VB scr0 = sil_reb_mem((VP)(siopcb->siopinib->cntrl+IOREG_SCR_OFFSET));

	if ((scr0 & SCR_RIE) != 0 && sh7047scif_getready (siopcb)) {
		/*
		 *  MʒmR[obN[`ĂяoD
		 */
		sh7047scif_ierdy_rcv (siopcb->exinf);
	}
}

/*
 *  SIOM݃T[rX[`(SCI3p)
 */
void
sh7047scif3_isr_out ()
{
	if (siopcb_table[0].openflag) {
		sh7047scif_isr_siop_out (&(siopcb_table[0]));
	}
}

/*
 *  SIOM݃T[rX[`(SCI4p)
 */
void
sh7047scif4_isr_out ()
{
	if (siopcb_table[1].openflag) {
		sh7047scif_isr_siop_out (&(siopcb_table[1]));
	}
}

/*
 *  SIOM݃T[rX[`(SCI3p)
 */
void
sh7047scif3_isr_in ()
{
	if (siopcb_table[0].openflag) {
		sh7047scif_isr_siop_in (&(siopcb_table[0]));
	}
}

/*
 *  SIOM݃T[rX[`(SCI4p)
 */
void
sh7047scif4_isr_in ()
{
	if (siopcb_table[1].openflag) {
		sh7047scif_isr_siop_in (&(siopcb_table[1]));
	}
}

/*
 *  SIOMG[݃T[rX[`(SCI3p)
 */
void
sh7047scif3_isr_error (void)
{
	UW base = siopcb_table[0].siopinib->cntrl;

	if (siopcb_table[0].openflag) {
		sil_wrb_mem((VP)(base+IOREG_SSR_OFFSET), sil_reb_mem((VP)(base+IOREG_SSR_OFFSET)) & ~(SSR_OPER|SSR_FER|SSR_PER));
	}
}

/*
 *  SIOMG[݃T[rX[`(SCI4p)
 */
void
sh7047scif4_isr_error (void)
{
	UW base = siopcb_table[1].siopinib->cntrl;

	if (siopcb_table[1].openflag) {
		sil_wrb_mem((VP)(base+IOREG_SSR_OFFSET), sil_reb_mem((VP)(base+IOREG_SSR_OFFSET)) & ~(SSR_OPER|SSR_FER|SSR_PER));
	}
}


