/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2002-2004 by Hokkaido Industrial Research Institute, JAPAN
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id$
 */

/*
 *  SH7047VAR~jP[VC^[tFCXSCIp ȈՃhCo
 */

#ifndef _SH7047SCIF_H_
#define _SH7047SCIF_H_

#include <t_config.h>

#define sh2scif_DELAY 105000

#ifndef _MACRO_ONLY

/*
 *  VAI/O|[gubN̒`
 */
typedef struct sio_port_initialization_block {
	UW	cntrl;		/* Rg[WX^̔Ԓn */
	UW  intctl;		/* ݃WX^̔Ԓn */
	UH	level;		/* ݃x */
	UH	shift;		/* ݃Vtg */
} SIOPINIB;

/*
 *  VAI/O|[gǗubN̒`
 *    2chT|[gɊgꍇ͏p̃f[^܂߂
 */
typedef struct sio_port_control_block
{
	const SIOPINIB	*siopinib;	/* VAI/O|[gubN */
	VP_INT	exinf;				/* g */
	BOOL	openflag;			/* I[vς݃tO */
} SIOPCB;

/*
 *  R[obN[`̎ʔԍ
 */
#define SIO_ERDY_SND	1u		/* M\R[obN */
#define SIO_ERDY_RCV	2u		/* MʒmR[obN */

/*
 *  SIOhCȍ[`
 */
extern void sh7047scif_initialize (void);

/*
 *  I[vĂ|[g邩H
 */
extern BOOL sh7047scif_openflag (ID siopid);

/*
 *  VAI/O|[g̃I[v
 */
extern SIOPCB *sh7047scif_opn_por (ID siopid, VP_INT exinf);

/*
 *  VAI/O|[g̃N[Y
 */
extern void sh7047scif_cls_por (SIOPCB * siopcb);

/*
 *  VAI/O|[gւ̕M
 */
extern BOOL sh7047scif_snd_chr (SIOPCB * siopcb, char c);

/*
 *  VAI/O|[g̕M
 */
extern INT sh7047scif_rcv_chr (SIOPCB * siopcb);

/*
 *  VAI/O|[g̃R[obN̋
 */
extern void sh7047scif_ena_cbr (SIOPCB * siopcb, UINT cbrtn);

/*
 *  VAI/O|[g̃R[obN̋֎~
 */
extern void sh7047scif_dis_cbr (SIOPCB * siopcb, UINT cbrtn);

/*
 *  SIO̊݃T[rX[`
 */
extern void sh7047scif_isr (void);

/*
 *  VAI/O|[g̑M\R[obN
 */
extern void sh7047scif_ierdy_snd (VP_INT exinf);

/*
 *  VAI/O|[g̎MʒmR[obN
 */
extern void sh7047scif_ierdy_rcv (VP_INT exinf);

#endif /* _MACRO_ONLY */

#endif /* _SH7047SCIF_H_ */
