/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

#ifndef	_CQ_D70F3716GC_H_
#define	_CQ_D70F3716GC_H_
/*
 *	vZbTɈˑ`iV850ES/JG2pj
 */

/*
 * RAM
 */
#define	IRAM_TOP	0x03FF9000		/* RAM̐擪AhX */
#define IRAM_SIZE	0x6000			/* RAM̑傫 24Kbyte */
/*
 * FlashROM
 */
#define	IROM_TOP	0x0000000		/* FlashROM̐擪AhX */
#define IROM_SIZE	0x40000			/* FlashROM̑傫 256Kbyte */


/* 
 * V850ES/JG2IOWX^`
 */
#define PRCMD		(0xFFFFF1FC)	/* Command Register */
#define VSWC		(0xFFFFF06E)	/* System Wait Control Register */
#define OCDM		(0xFFFFF9FC)	/* OnChip Debug Mode Register */
#define WDTM2		(0xFFFFF6D0)	/* Watchdog Debug Mode Register2 */

/*
 * NbN֘A
 */
#define PCC			(0xFFFFF828)	/* Processor Clock Control Register */
#define PLLCTL		(0xFFFFF82C)	/* PLL Rg[EWX^ */

/*
 * LED֘A
 */
/* |[gCT */
#define PCT			(0xFFFFF00A)	/* PCT Register vector */
#define PMCT		(0xFFFFF02A)	/* PCT Mode Register vector */
#define PMCCT		(0xFFFFF04A)	/* PCT Mode Control Register vector */

#define LED_BIT		(0x40)			/* LED */

/*
 * 16bit Interval Timer M
 */
#define TM0CTL0		(0xFFFFF690)
#define TM0CMP0		(0xFFFFF694)

/*
 * UART0֘A
 */
/* |[g */
#define PMC3		(0xFFFFF446)
#define PFC3		(0xFFFFF466)
#define PFCE3L		(0xFFFFF706)

/* UART0 */
#define UA0CTL0		(0xFFFFFA00)	/* UARTA0 䃌WX^0 */
#define UA0OPT0		(0xFFFFFA03)	/* UARTA0 IvV䃌WX^0 */
#define UA0STR		(0xFFFFFA04)	/* UARTA0 ԃWX^ */
#define UA0RX		(0xFFFFFA06)	/* UARTA0 Mf[^WX^ */
#define UA0TX		(0xFFFFFA07)	/* UARTA0 Mf[^WX^ */

/* {[[g */
#define UA0CTL1		(0xFFFFFA01)	/* UARTA0 䃌WX^1 */
#define UA0CTL2		(0xFFFFFA02)	/* UARTA0 䃌WX^2 */

/*
 * IntC
 */
#define TM0EQIC0	(0xFFFFF150)	/* TM0EQ0 ݐ䃌WX^ */
#define UA0RIC		(0xFFFFF162)	/* UART0 Mݐ䃌WX^ */
#define UA0TIC		(0xFFFFF164)	/* UART0 Mݐ䃌WX^ */
#define IMR2		(0xFFFFF104)	/* ݃}XNWX^2 */
#define IMR2H		(0xFFFFF105)	/* ݃}XNWX^2H */
#define IMR2L		(0xFFFFF104)	/* ݃}XNWX^2L */
#define ISPR		(0xFFFFF1FA)	/* CT[rXEvCIeBEWX^ */

#endif	/* _CQ_D70F3716GC_H_ */
