/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 * ^[QbgˑVAI/OW[iD70F3716GC 񓯊VAch0pj
 *   f[^tH[}bg8bit data, non-parity, 1stop-bitŒ
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

#include <s_services.h>

/*
 *  VA|[g̏ubN
 */

typedef struct sio_port_initialization_block {
} SIOPINIB;

/*
 *  VA|[g̐ubN
 */
typedef struct sio_port_control_block {
	const SIOPINIB	*inib;		/* ubN	*/
	VP_INT		exinf;		/* g		*/
	BOOL		openflag;	/* I[vς݃tO	*/
	int			port_id;	/* |[gԍ(0`) */
} SIOPCB;

extern SIOPCB siopcb_table[TNUM_PORT];

/*
 *  SIO ID ǗubNւ̕ϊ}N
 */

#define INDEX_SIO(sioid)	((UINT)((sioid) - 1))
#define get_siopcb(sioid)	(&(siopcb_table[INDEX_SIO(sioid)]))

/*
 *  R[obN[`̎ʔԍ
 */

#define SIO_ERDY_SND		1u			/* M\R[obN			*/
#define SIO_ERDY_RCV		2u			/* MʒmR[obN			*/


/*
 *  VA|[g̃n[hEFAˑ̒`
 */

#define SERIAL_PORT				(CONSOLE_PORTID-1)		/* VXẽ|[gԍ */
#define SERIAL_INT_PRIORITY		3	/* 荞ݗDx */
#define SERIAL_CLKDIV			0x01	/* clk = fxx/2     */
#define SERIAL_COMPAREVALUE		0x82	/* 38400bps */
//#define SERIAL_CLKDIV			0x00	/* clk = fxx/1     */
//#define SERIAL_COMPAREVALUE		0x57	/* 115200bps */


#define FLG_RECEIVED 1

extern volatile unsigned int _serial_flag;


/*
 *  VAI/O̊݃nh̃xN^ԍ
 */
#define INHNO_SERIAL_IN		(0x31)
#define INHNO_SERIAL_OUT	(0x32)

/*
 *  ჌x|[gǗubN̏l
 */

#define NUM_PORT	1	/* T|[gVA|[g̐ */

/*
 *  VAI/O|[g̏
 */
Inline BOOL
hw_port_initialize(int port_id)
{
#ifndef DEBUGGER
	while( (sil_reb_mem((VP)UA0STR) & 0x80) ) ;

	/* 񓯊VAʐMH̏ */

	/* |[gJ */
	if (port_id == 0) {
		sil_wrh_mem((VP)PMC3, sil_reh_mem((VP)PMC3) | 0x0003);
		sil_wrh_mem((VP)PFC3, sil_reh_mem((VP)PFC3) & ~0x0003);
		sil_wrb_mem((VP)PFCE3L, 0x0000);
	} else {

	}

	/* {[[g̏ */
	sil_wrb_mem((VP)UA0CTL1, SERIAL_CLKDIV);
	sil_wrb_mem((VP)UA0CTL2, SERIAL_COMPAREVALUE);

	sil_wrb_mem((VP)UA0CTL0, 0x80);	/* enable ASIO */

	__asm("nop; nop");

	/* peBȂE8rbgEXgbv1rbgELSBt@[Xg */
	sil_wrb_mem((VP)UA0CTL0, sil_reb_mem((VP)UA0CTL0) | 0x12);

	__asm("nop; nop");

	sil_wrb_mem((VP)UA0CTL0, sil_reb_mem((VP)UA0CTL0) | 0x60);	/* Tx, Rx enable */

	/* ݐ */
	sil_wrb_mem((VP)UA0RIC, SERIAL_INT_PRIORITY);
	sil_wrb_mem((VP)UA0TIC, SERIAL_INT_PRIORITY);
#endif
	return(FALSE);
}

/*
 *  VAI/O|[g̏I
 */
Inline void
hw_port_terminate(int port_id)
{
	sil_wrb_mem((VP)UA0RIC, sil_reb_mem((VP)UA0RIC) | 0x40);
	sil_wrb_mem((VP)UA0TIC, sil_reb_mem((VP)UA0TIC) | 0x40);

	sil_wrb_mem((VP)UA0CTL0, 0x10);	/* Tx, Rx disable */
}

/*
 *  VA|[g݃T[rX[`iOQƁj
 */
extern void	serial_handler_in(int portid);
extern void	serial_handler_out(int portid);

/*
 *  MH
 */
Inline BOOL
hw_port_getready(int port_id)
{
	return ((_serial_flag & FLG_RECEIVED) != 0);
}


/*
 *  𑗐Mł邩H
 */
Inline BOOL
hw_port_putready(int port_id)
{
	return ((sil_reb_mem((VP)UA0STR) & 0x80) == 0);
}


/*
 *  M̎o
 */
Inline unsigned char
hw_port_getchar(int port_id)
{
	_serial_flag &= ~FLG_RECEIVED;
	return sil_reb_mem((VP)UA0RX);
}

/*
 *  M镶̏
 */
Inline void
hw_port_putchar(int port_id, unsigned char c)
{
	sil_wrb_mem((VP)UA0TX, c);
}

/*
 *  M镶̏݁iM\ɂȂ܂ő҂j
 */
Inline void
hw_port_wait_putchar(int port_id, unsigned char c)
{
	while( !hw_port_putready(port_id) ) ;
	hw_port_putchar(port_id, c);
}

/*
 *  M֐
 */
Inline void
hw_port_sendstart(int port_id)
{
}

Inline void
hw_port_sendstop(int port_id)
{
}

extern void	sio_ierdy_rcv(VP_INT exinf);
extern void	sio_ierdy_snd(VP_INT exinf);

Inline void
hw_port_handler_in(int port_id)
{
	UB tmp;

	if((sil_reb_mem((VP)UA0STR) & 0x07) == 0) {
		_serial_flag |= FLG_RECEIVED;
		sio_ierdy_rcv(siopcb_table[port_id].exinf);	
	} else {
		/* G[΃f[^j */
		tmp = sil_reb_mem((VP)UA0RX);
	}
}

Inline void
hw_port_handler_out(int port_id)
{
	if(hw_port_putready(port_id)) {
		sio_ierdy_snd(siopcb_table[port_id].exinf);
	}
}

/***********************************************************************************/

/*
 *  sio_initialize -- VA|[ghCȍ
 */
Inline void
sio_initialize (void)
{
	int ix;

	/* SIO ǗubN̏ */
	for (ix = TNUM_PORT; ix -- > 0; ) {
		siopcb_table[ix].openflag = FALSE;
	}
}

/*
 *  sio_opn_por -- |[g̃I[v
 */
Inline SIOPCB *
sio_opn_por(ID sioid, VP_INT exinf)
{
	SIOPCB	*pcb;

	pcb = get_siopcb(sioid);
	pcb->inib     = NULL;
	pcb->exinf    = exinf;
	pcb->openflag = TRUE;
	pcb->port_id  = sioid-1;
	hw_port_initialize(pcb->port_id);
	return pcb;
}

/*
 *  sio_snd_chr -- M
 */
Inline BOOL
sio_snd_chr(SIOPCB *pcb, INT chr)
{
#if 0
	if (hw_port_putready(pcb->port_id)) {
		hw_port_putchar(pcb->port_id, (UB)chr);
		return TRUE;
	} else {
		return FALSE;
	}
#else
	/* {́Â悤ɂׂA */
	/* syslogo͂~܂Ă܂߁A */
	/* b菈u */
	while(!hw_port_putready(pcb->port_id)) ;
	hw_port_putchar(pcb->port_id, (UB)chr);
	return TRUE;
#endif
}

/*
 *  sio_rcv_chr -- M
 */
Inline INT
sio_rcv_chr(SIOPCB *pcb)
{
	if (hw_port_getready(pcb->port_id))
		return hw_port_getchar(pcb->port_id);
	else
		return -1;
}

/*
 *  sio_ena_cbr -- VA I/O ̃R[obN̋
 */
Inline void
sio_ena_cbr(SIOPCB *pcb, UINT cbrtn)
{
}

/*
 *  sio_dis_cbr -- VA I/O ̃R[obN̋֎~
 */
Inline void
sio_dis_cbr(SIOPCB *pcb, UINT cbrtn)
{
}

/*
 *  sio_cls_por -- |[g̃N[Y
 */
Inline void
sio_cls_por(SIOPCB *pcb)
{
	sio_dis_cbr(pcb, SIO_ERDY_SND);
	sio_dis_cbr(pcb, SIO_ERDY_RCV);
	pcb->openflag = FALSE;
}

Inline void
sio_in_handler(void)
{
	hw_port_handler_in(0);
}

Inline void
sio_out_handler(void)
{
	hw_port_handler_out(0);
}


#endif /* _HW_SERIAL_H_ */
